//
//  Defkon.h
//
#include "deftype.h"

#define MANN_SIZE       31
#define STRG            36
#define ML              MannListe
#define FL              FeindListe
#define MF              MannFeld
#define Mlinks          0   //73
#define Mrechts         320 //315
#define Moben           -1   //11
#define Munten          200 //191
#define Hindernis       16


BYTE LandData[500000], MannData[500000], MannBack[500000], FeindBack[500000];
BYTE Feld[200][200];
int  MannFeld[200][200]; 
BYTE AktListe[200], MoveListe[400];
MANN MannListe[200], FeindListe[200];
int f_x=0; f_y=0, MannAnzahl= -1, FeindAnzahl= -1, scroll_del, mann_del, ss_del, sm_del;
int sdel;
int aktive = 0;
BYTE akt[6];
int SPIEL_LANG  = 10;
int SPIEL_BREIT = 16;
int VIEW_LANG  = 4, vx=230;
int VIEW_BREIT = 3; vy=130;
int FELD_X;
int FELD_Y;
int Radar_x, Radar_y, Radar_x1, Radar_y1, intro;
BYTE radar_akt=1;
int x_lang, y_breit, aktzaehler;
char karte[13];
char pal[768];
BYTE O_ANFANG, U_ANFANG, R_ANFANG, L_ANFANG, MANN_DIV, O_LANG,
     U_LANG, R_LANG, L_LANG, ANGRIF_L, ANGRIF_R, ANGRIF_O, ANGRIF_U,
     ANGRIF_LL, ANGRIF_RL, ANGRIF_OL, ANGRIF_UL;
WORD geld, geldchange=0;
BYTE panel_akt=0;

/****************************************************************************/
/* put_sprite bring ein Sprite von 20x20 auf den Bildschirm. Zuvor mu ihr  */
/* aber die Position des Sprites im XMS bergeben werden, sowie die X- und  */
/* Y-Koordinaten.                                                           */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            x................................... X-Koordinate des Sprites */
/*            y................................... Y-Koordinate des Sprites */
/*            pos................................... Sprite-Position im XMS */
/****************************************************************************/
void put_sprite( int x, int y, unsigned int pos )
{
  int i;

  for(i=0; i<20; i++)
  {
    memcpy(&VScreen[((y+i)*320)+x], &LandData[pos+(i*20)], 20);
  }
}

void put_black_sprite( int x, int y )
{
  int i;

  for(i=0; i<20; i++)
  {
    memset(&Screen[((y+i)*320)+x], 0, 20);
  }
}


/****************************************************************************/
/* Dies Funktion stellt das Grundgrst fr diese Spiel dar. Sie berechnet   */
/* welche Teile der Landschaft (Karte) angezeigt werden soll.               */
/* Gesteuert wird per Maus.                                                 */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            weiter_x..................... wie weit in X-Richtung scrollen */
/*            weiter_y..................... wie weit in Y_Richtung scrollen */
/****************************************************************************/
void Landschaft ( int weiter_x, int weiter_y )
{
  int i, j;
  char strgeld[5];

  for (i=weiter_y; i<weiter_y+SPIEL_LANG; i++)          
  {
    for (j=weiter_x; j<weiter_x+SPIEL_BREIT; j++)
    {
      put_sprite((j-weiter_x)*20, (i-weiter_y)*20, Feld[i][j]*400);
    }
  }
  if ( radar_akt ) draw_box(Radar_x, Radar_y, Radar_x1-1, Radar_y1+1, 247);
}


/****************************************************************************/
/* Initialisiert das Programm an sich.                                      */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void Init_Program( void )
{
  int i, Zeichen;
  char DateiName[127];

  printf("Starte Defkon17-Alpha Version v0.1\n");
  delay(1000);
  if ( maus_reset() )        // berprfen ob ein Maustreiber installiert ist
  {
   printf("\n\nERROR: Es wurde kein Maustreiber gefunden!\n\n");
   exit(0);
  }
  load_ini(); ss_del = scroll_del; sm_del = mann_del;

  if ( chdir("DATA") )                       // ins DATA-Verzeichnis wechseln
  {
    printf("\n\nERROR: Kann Verzeichnis DATA nicht finden!\n\n");
    exit(0);
  }                                          
  init320x200();
  maus_off(); maus_put(160, 100);                              // Maus setzen
}

/****************************************************************************/
/* Initialisiert das ein Spiel. (vom Men aus)                              */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void Init_Spiel ( char type )
{
  int i, Zeichen;
  char puffer[13];
  FILE *Datei;

  if ( type )
  {
    MannAnzahl = FeindAnzahl = -1;
    f_x = f_y = 0;
    aktzaehler = -1; geld=40000;
    memset(AktListe, 0, 200);
    memset(MoveListe, 0, 400);
  }
  memset(MannFeld, 0, 200*200*2);

  if ( (Datei = fopen("terrain.ref", "rb")) == NULL )     // Landschaft laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'terrain.ref' nicht laden!\n\n");
    exit(0);
  }
  i= 0; 
  while ((Zeichen = fgetc(Datei)) != EOF) LandData[i++] = (BYTE)Zeichen;
  fclose(Datei);
  if ( (Datei = fopen("mann.ref", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'mann.ref' nicht laden!\n\n");
    exit(0);
  }
  i=0;
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
  load_num();

  if ( (Datei = fopen("font.ref", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'font.ref' nicht laden!\n\n");
    exit(0);
  }
  i=0;
  while ((Zeichen = fgetc(Datei)) != EOF) bchst[i++] = (BYTE)Zeichen;
  fclose(Datei);

  if ( type ) load_gam(karte);
  else load_gamap(karte);

  if ( type )
  {
    Screen_Off();
    UpdateScreen();
    maus_off(); maus_put(160, 100);
  }
  if ( !type ) UpdateScreen();
  if ( MannAnzahl > -1 ) for (i=0; i<=MannAnzahl; i++); mann_set(i);
  if ( FeindAnzahl > -1 ) for (i=0; i<=FeindAnzahl; i++); feind_set(i);

  LoadPalette("mr-005.dbl", pal); SetPalette(pal); Set_Overscan_Color(0);
  m_back_save(); m_place();
  cpy2screen(); Screen_On();

}

/****************************************************************************/
/* Maushandler fr die Funktion Spiel().                                    */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
int maus_links ( void )
{
  int i, j, h, k;
  BYTE kb;
  union REGS regs;

  regs.x.ax = 0x0200;      
  int386( 0x16, &regs, &regs );
  kb = regs.h.al;


  if ( (m_x>0)&&(m_x<40)&&(m_y>0)&&(m_y<10) ) { if ( spiel_menu() ) return 1; else return 0; }
  if ( (m_x>240)&&(m_x<278)&&(m_y>0)&&(m_y<9)&&(!radar_akt) ) { radar_akt=1; UpdateScreen(); return 0; }
  if ( maus_innen(279, 0, 319, 10) ) { if ( !panel_akt ) panel_akt = 1; UpdateScreen(); return 0; }
  if ( (m_x>Radar_x-1)&&(m_x<Radar_x+4)&&(m_y>Radar_y-1)&&(m_y<Radar_y+4)&&(radar_akt) )
  {
     radar_akt = 0; UpdateScreen();
     return 0;
  }

  if ( (m_x>Mlinks)&&(m_x<Mrechts)&&(m_y>Moben)&&(m_y<Munten) ) // wenn auf Spielfeld
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      if ( (m_x>FL[i].x-15)&&(m_x<FL[i].x+15)&&(m_y>FL[i].y-15)&&(m_y<FL[i].y+15) )
      {
        for ( j=0; j<MannAnzahl+1; j++ )
        {
          if ( AktListe[j] == 1 ) { ML[j].stop = 2; ML[j].attack = i; } // angreifen
        }
      }
    }
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( (m_x>ML[i].x-15)&&(m_x<ML[i].x+15)&&(m_y>ML[i].y-15)&&(m_y<ML[i].y+15) )
      {
        if ( AktListe[i] ) return 0;                     // is schon markiert
        if ( kb == 32 )
	{
          for ( j=0; j<MannAnzahl+1; j++ )        // alle anderen demarkieren
	    if ( AktListe[j] )
	    {
               mann_back_restore(j); mann_set(j); AktListe[j]=0; 
	    } 
          aktive = 0;
        }
        AktListe[i] = 1; m_show_image=6; go=1; aktive++;
        m_back_restore(); mann_back_restore(i); mann_akt_set(i); m_back_save(); m_place();
	m_taste= 0; return 0;
      }
    }
    if ( !noway )
    {
      k=h=0;
      for ( i=0; i<MannAnzahl+1; i++ )
      { 
        if ( (AktListe[i]) )
        {
          if ( h == aktive/2 ) { k++; h=0; }
          ML[i].dx=((f_x+1+(m_x/20)+h)*20); ML[i].dy=((f_y+(m_y/20)+k)*20); ML[i].stop=0;
          ML[i].stop=0; h++;
        }
      }
    }
    return 0;
  }

  return 0;
}

/****************************************************************************/
/* Maushandler fr die Funktion Spiel().                                    */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void maus_rechts ( void )
{
  int i;

  for ( i=0; i<MannAnzahl+1; i++ )
  {
    if ( AktListe[i] ) { mann_back_restore(i); mann_set(i); }
    AktListe[i] = 0;
  }
  go=0; atack=0; aktzaehler = -1; aktive = 0;
}

void UpdateScreen ( void )
{
  int i, j;
  char strgeld[5];


  for (i=f_y; i<f_y+SPIEL_LANG; i++)
  {
    for (j=f_x; j<f_x+SPIEL_BREIT; j++)
    {
      put_sprite((j-f_x)*20, (i-f_y)*20, Feld[i][j]*400);
    }
  }

  if ( radar_akt ) draw_box(Radar_x, Radar_y, Radar_x1-1, Radar_y1+1, 247);
  button_up(1, 0, 40, "menu");

  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( (ML[i].x<320)&&(ML[i].x>-20)&&(ML[i].y<200)&&(ML[i].y>-20) )
      {
        if ( AktListe[i] ) mann_akt_set(i);
        else mann_set(i);
      }
    }
  }
  if ( FeindAnzahl > -1 )
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      if ( (FL[i].x<320)&&(FL[i].x>-20)&&(FL[i].y<200)&&(FL[i].y>-20) ) feind_set(i);
    }
  }
}

void scroll_down ( void )
{
  int i;

  sdel=0; f_y++;
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].y1=ML[i].y-=20; 
      if ( (ML[i].x<320)&&(ML[i].x>-20)&&(ML[i].y<200)&&(ML[i].y>-20) )
      {
        if ( AktListe[i] ) mann_akt_set(i);
        else mann_set(i);
      }
    }
  }
  if ( FeindAnzahl > -1 )
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].y1=FL[i].y-=20;
      if ( (FL[i].x<320)&&(FL[i].x>-20)&&(FL[i].y<200)&&(FL[i].y>-20) ) feind_set(i);
    }
  }
  m_show_image=m_down;
}

void scroll_up ( void )
{
  int i;

  sdel=0; f_y--;
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].y1=ML[i].y+=20; 
      if ( (ML[i].x<320)&&(ML[i].x>-20)&&(ML[i].y<200)&&(ML[i].y>-20) )
      {
        if ( AktListe[i] ) mann_akt_set(i);
        else mann_set(i);
      }
    }
  }
  if ( FeindAnzahl > -1 )
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].y1=FL[i].y+=20;
      if ( (FL[i].x<320)&&(FL[i].x>-20)&&(FL[i].y<200)&&(FL[i].y>-20) ) feind_set(i);
    }
  }
  m_show_image=m_up; 
}

void scroll_right ( void )
{
  int i;

  sdel=0; f_x++;
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].x1=ML[i].x-=20;
      if ( (ML[i].x<320)&&(ML[i].x>-20)&&(ML[i].y<200)&&(ML[i].y>-20) )
      {
        if ( AktListe[i] ) mann_akt_set(i);
        else mann_set(i);
      }
    }
  }
  if ( FeindAnzahl > -1 )
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].x1=FL[i].x-=20;
      if ( (FL[i].x<320)&&(FL[i].x>-20)&&(FL[i].y<200)&&(FL[i].y>-20) ) feind_set(i);
    }
  }
  m_show_image=m_right; 
}

void scroll_left ( void )
{
  int i;

  sdel=0; f_x--;
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].x1=ML[i].x+=20; 
      if ( (ML[i].x<320)&&(ML[i].x>-20)&&(ML[i].y<200)&&(ML[i].y>-20) )
      {
        if ( AktListe[i] ) mann_akt_set(i);
        else mann_set(i);
      }
    }
  }
  if ( FeindAnzahl > -1 )
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].x1=FL[i].x+=20;
      if ( (FL[i].x<320)&&(FL[i].x>-20)&&(FL[i].y<200)&&(FL[i].y>-20) ) feind_set(i);
    }
  }
  m_show_image=m_left;
}

/****************************************************************************/
/* Ld eine Karte.                                                          */
/* ------------------------------------------------------------------------ */
/* Parameter: Dateiname.                                                    */
/****************************************************************************/
void load_gam ( char *Datei )
{
  int i, j;
  FILE *D;
  char sign[2];

  if ( (D = fopen(Datei, "rb")) == NULL )
  {
    printf("\n\nERROR: Kann Datei '%s' nicht laden!\n\n", Datei);
    exit(0);
  }
  sign[0] = 'S'; sign[1] = 'M';
//------------------------------ Header --------------------------------------
  sign[0] = fgetc(D); sign[1] = fgetc(D);
  FELD_X = fgetc(D); x_lang = FELD_X + 12;
  FELD_Y = fgetc(D); y_breit = FELD_Y + 10;
  MannAnzahl =  fgetc(D); MannAnzahl--;
  FeindAnzahl = fgetc(D); FeindAnzahl--;
//---------------------------- Karte speichern -------------------------------
  for ( i=0; i<(FELD_Y+11); i++)
  {
    for ( j=0; j<(FELD_X+13); j++) Feld[i][j] = fgetc(D);
  }
//---------------------------- Kennung fr Leute ---------------------------------------------------------------------------------------------
  sign[0] = fgetc(D);
  if ( (MannAnzahl > -1) )  for(i=0; i<MannAnzahl+1; i++)  { fget_Mann(D, &ML[i]); ML[i].y = ML[i].ay-(f_y*20); ML[i].x = ML[i].ax-(f_x*20); }
  if ( (FeindAnzahl > -1) ) for(i=0; i<FeindAnzahl+1; i++) { fget_Mann(D, &FL[i]); FL[i].y = FL[i].ay-(f_y*20); FL[i].x = FL[i].ax-(f_x*20); }

//--------------------------------------------------------------------------------------------------------------------------------------------
  fclose(D);
}


void load_gamap ( char *Datei )
{
  int i, j;
  FILE *D;
  char sign[2];

  if ( (D = fopen(Datei, "rb")) == NULL )
  {
    printf("\n\nERROR: Kann Datei '%s' nicht laden!\n\n", Datei);
    exit(0);
  }
  sign[0] = 'S'; sign[1] = 'M';
//------------------------------ Header --------------------------------------
  sign[0] = fgetc(D); sign[1] = fgetc(D);
  FELD_X = fgetc(D); x_lang = FELD_X + 12;
  FELD_Y = fgetc(D); y_breit = FELD_Y + 10;
  sign[0] =  fgetc(D); sign[0] = fgetc(D); 
//---------------------------- Karte speichern -------------------------------
  for ( i=0; i<(FELD_Y+11); i++)
  {
    for ( j=0; j<(FELD_X+13); j++) Feld[i][j] = fgetc(D);
  }

//--------------------------------------------------------------------------------------------------------------------------------------------
  fclose(D);
}


/****************************************************************************/
/* Speichert das momentane Spiel ab.                                        */
/* ------------------------------------------------------------------------ */
/* Parameter: Name des SaveGames.                                           */
/****************************************************************************/
void save_game ( char DateiName[13], char Name[50] )
{
  FILE *Datei;
  char sign[2]="SM";
  int i, j;

  if ( (Datei = fopen(DateiName, "wb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann in Datei '%s' nicht schreiben!\n\n", DateiName);
    exit(0);
  }
  fwrite(sign, 2, 1, Datei);                                      // Signatur
  fwrite(Name, 50, 1, Datei);                                // Savegame-Name
  fwrite(karte, 13, 1, Datei);                                  // x.map Name

  fputc(MannAnzahl+1, Datei);                                   // MannAnzahl
  fputc(FeindAnzahl+1, Datei);                                 // FeindAnzahl
  fputc(f_x, Datei); fputc(f_y, Datei);                 // Karten-Koordinaten
  for(i=0; i<=200; i++) fputc(AktListe[i], Datei);                // AktListe
  if ( (MannAnzahl > -1) )
  {
    for(i=0; i<MannAnzahl+1; i++) fput_Mann(Datei, &ML[i]);
    for(i=0; i<=((MannAnzahl+1)*400); i++) fputc(MannBack[i], Datei); // MannBack
  }
  if ( (FeindAnzahl > -1) )
  {
    for(i=0; i<FeindAnzahl+1; i++) fput_Mann(Datei, &FL[i]);
    for(i=0; i<=((FeindAnzahl+1)*400); i++) fputc(FeindBack[i], Datei);// FeindBack
  }

  fclose(Datei);
  chdir(".."); chdir("data");
}

/****************************************************************************/
/* Ld ein zuvor gespeichertes Spiel.                                       */
/* ------------------------------------------------------------------------ */
/* Parameter: Name des SaveGames.                                           */
/****************************************************************************/
void load_game ( char DateiName[13] )
{
  FILE *Datei;
  char sign[1], Name[50];
  int i, j;

  memset(sign, 0, 2);
  if ( (Datei = fopen(DateiName, "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann Datei '%s' nicht laden!\n\n", DateiName);
    exit(0);
  }
  sign[0] = fgetc(Datei); sign[1] = fgetc(Datei);                 // Signatur
  fread(Name, 50, 1, Datei);                                 // Savegame-Name
  fread(karte, 13, 1, Datei);                                   // x.map Name
  MannAnzahl  = fgetc(Datei); MannAnzahl--;                     // MannAnzahl
  FeindAnzahl = fgetc(Datei); FeindAnzahl--;                   // FeindAnzahl
  f_x = fgetc(Datei); f_y = fgetc(Datei);               // Karten-Koordinaten
  for(i=0; i<=200; i++) AktListe[i] = fgetc(Datei);               // AktListe
  if ( (MannAnzahl > -1) )
  {
    for(i=0; i<MannAnzahl+1; i++) fget_Mann(Datei, &ML[i]);
    for(i=0; i<=((MannAnzahl+1)*400); i++) MannBack[i] = fgetc(Datei);// MannBack
    for(i=0; i<MannAnzahl+1; i++) { ML[i].y = ML[i].ay-(f_y*20); ML[i].x = ML[i].ax-(f_x*20); }
  }
  if ( (FeindAnzahl > -1) )
  {
    for(i=0; i<FeindAnzahl+1; i++) fget_Mann(Datei, &FL[i]);
    for(i=0; i<=((FeindAnzahl+1)*400); i++) FeindBack[i] = fgetc(Datei);// FeindBack
    for(i=0; i<FeindAnzahl+1; i++) { FL[i].y = FL[i].ay-(f_y*20); FL[i].x = FL[i].ax-(f_x*20); }
  }

  fclose(Datei);
  chdir(".."); chdir("data");
}

int get_ini_value ( FILE *D )
{
  char ini[5];
  int i= 0;

  memset(ini, 32, 5);
  while ( fgetc(D) != '=' );
  while ( (ini[i++] = fgetc(D)) != ':');
  return atoi(ini); 
}

/****************************************************************************/
/* Wertet die INI-Datei aus, und setzt die dazugehrigen Variablen          */
/* ------------------------------------------------------------------------ */
/* Keine Parameter.                                                         */
/****************************************************************************/
void load_ini ( void )
{
  int i;
  FILE *Datei;

  if ( (Datei = fopen("defkon.ini", "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann 'defkon.ini' nicht laden!\n\n");
    exit(0);
  }
//---------------------- scroll_del ------------------------------------------
    scroll_del = get_ini_value(Datei); 
//---------------------- mann_del --------------------------------------------
    mann_del = get_ini_value(Datei); 
//---------------------- Intro -----------------------------------------------
    intro = get_ini_value(Datei); 
//---------------------- Radar_x ---------------------------------------------
    Radar_x = get_ini_value(Datei); 
//---------------------- Radar_y ---------------------------------------------
    Radar_y = get_ini_value(Datei); 
//---------------------- Radar_x1 --------------------------------------------
    Radar_x1 = get_ini_value(Datei); 
//---------------------- Radar_y1 --------------------------------------------
    Radar_y1 = get_ini_value(Datei); 
//---------------------- radar_akt -------------------------------------------
    radar_akt = get_ini_value(Datei); i= 0;
//---------------------- karte -----------------------------------------------
  memset(karte, 0, 13); while ( fgetc(Datei) != '=' ); while ( (karte[i++] = fgetc(Datei)) != ':');
  karte[--i] = 0x00;

  fclose(Datei);
}


/****************************************************************************/
/* Wertet die NUM-Datei aus, und setzt die dazugehrigen Variablen          */
/* ------------------------------------------------------------------------ */
/* Keine Parameter.                                                         */
/****************************************************************************/
void load_num ( void )
{
  FILE *Datei;

  if ( (Datei = fopen("mann.num", "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann 'mann.num' nicht laden!\n\n");
    exit(0);
  }
//----------------------L_ANFANG ---------------------------------------------
   L_ANFANG = get_ini_value(Datei);
   L_LANG   = get_ini_value(Datei);
//----------------------R_ANFANG ---------------------------------------------
   R_ANFANG = get_ini_value(Datei);
   R_LANG   = get_ini_value(Datei);
//----------------------O_ANFANG ---------------------------------------------
   O_ANFANG = get_ini_value(Datei);
   O_LANG   = get_ini_value(Datei);
//----------------------U_ANFANG ---------------------------------------------
   U_ANFANG = get_ini_value(Datei);
   U_LANG   = get_ini_value(Datei);
//----------------------MANN_DIV ---------------------------------------------
   MANN_DIV = get_ini_value(Datei);

//----------------------ANGRIF_L ---------------------------------------------
  ANGRIF_L  = get_ini_value(Datei);
  ANGRIF_LL = get_ini_value(Datei);
//----------------------ANGRIF_R ---------------------------------------------
  ANGRIF_R  = get_ini_value(Datei);
  ANGRIF_RL = get_ini_value(Datei);
//----------------------ANGRIF_O ---------------------------------------------
  ANGRIF_O  = get_ini_value(Datei);
  ANGRIF_OL = get_ini_value(Datei);
//----------------------ANGRIF_U ---------------------------------------------
  ANGRIF_U  = get_ini_value(Datei);
  ANGRIF_UL = get_ini_value(Datei);


  fclose(Datei);
}




/****************************************************************************/
/* Beendet das Spiel.                                                       */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void quit ( void )
{
  chdir("..");
  textmodus();
  printf("Du hast diese Zeit verloren!\n");
  exit(0);
}


