//
// laser.h
//
void LaserInsert ( short ax, short ay, short dx, short dy, short destruct, byte length, byte speed, byte farbe, short owner )
{
  short i;

  LaserAnz++;
  if ( LaserAnz >= LASERMAX ) { LaserAnz--; return; }

  memset(&Laser[LaserNextFree], 0, sizeof(LASER));

  Laser[LaserNextFree].free         = 1;
  Laser[LaserNextFree].ax           = ax;
  Laser[LaserNextFree].ay           = ay;
  Laser[LaserNextFree].dx           = dx;
  Laser[LaserNextFree].dy           = dy;
  Laser[LaserNextFree].length       = length;
  Laser[LaserNextFree].speed        = speed; 
  Laser[LaserNextFree].destruct     = destruct;
  Laser[LaserNextFree].farbe        = farbe;   
  Laser[LaserNextFree].owner        = owner;   

  InitLaser(LaserNextFree);

  for(i=LaserNextFree; i<EMAX; ++i) if ( !Laser[i].free ) { LaserNextFree = i; return; }
}



void InitLaser ( short index )
{
  if ( abs((Laser[index].dx-Laser[index].ax)) < abs((Laser[index].dy-Laser[index].ay)) )
  {
    if ( Laser[index].ay > Laser[index].dy )
    {
      Laser[index].l.yincr = -1;
      Laser[index].l.dy = Laser[index].ay - Laser[index].dy;                                      
    }
    else
    {
      Laser[index].l.yincr = 1;
      Laser[index].l.dy = Laser[index].dy - Laser[index].ay;
    }
    Laser[index].l.div = 1;

    if ( Laser[index].dx > Laser[index].ax ) Laser[index].l.xincr = 1;
    else Laser[index].l.xincr = -1;
    Laser[index].l.dx = abs( Laser[index].dx-Laser[index].ax );                                      // rel. X-Lnge
    Laser[index].l.d  = 2 * Laser[index].l.dx - Laser[index].l.dy;
    Laser[index].l.aincr = 2 * (Laser[index].l.dx - Laser[index].l.dy);
    Laser[index].l.bincr = 2 * Laser[index].l.dx;
    Laser[index].l.x = Laser[index].ax;
    Laser[index].l.y = Laser[index].ay;
  }
  else
  {
    if ( Laser[index].ax > Laser[index].dx )
    {
      Laser[index].l.xincr = -1;
      Laser[index].l.dx = Laser[index].ax - Laser[index].dx;
    }
    else
    {
      Laser[index].l.xincr = 1;
      Laser[index].l.dx = Laser[index].dx - Laser[index].ax;
    }

    Laser[index].l.div = 0;

    if ( Laser[index].dy > Laser[index].ay ) Laser[index].l.yincr = 1;
    else Laser[index].l.yincr = -1;
    Laser[index].l.dy = abs( Laser[index].dy-Laser[index].ay );
    Laser[index].l.d  = 2 * Laser[index].l.dy - Laser[index].l.dx;           
    Laser[index].l.aincr = 2 * (Laser[index].l.dy - Laser[index].l.dx);      
    Laser[index].l.bincr = 2 * Laser[index].l.dy;
    Laser[index].l.x = Laser[index].ax;
    Laser[index].l.y = Laser[index].ay;
  }
}


void LaserDelete ( short index )
{
  EAnz--;
  Laser[index].free = 0;

  if ( index < LaserNextFree ) LaserNextFree = index;
  Leute[Laser[index].owner].attack = 0;
  Leute[Laser[index].owner].who    = 255;
}


void LaserCompute ( short index )
{
  short i;
  LINE  puffer;

  for(i=0; i<Laser[index].speed; i++) CalcLaserPoint(index);

  memcpy(&puffer, &Laser[index].l, sizeof(LINE));

  for(i=0; i<Laser[index].length; i++)
  {
    CalcLaserPoint(index);
    ssetpix(Laser[index].l.x-ScrollX, Laser[index].l.y-ScrollY, Laser[index].farbe);
  }

  memcpy(&Laser[index].l, &puffer, sizeof(LINE));
}


void CalcLaserPoint ( short index )
{
   if ( Laser[index].l.div  )
   {
     if ( Laser[index].l.d >= 0 ) { Laser[index].l.x += Laser[index].l.xincr; Laser[index].l.d += Laser[index].l.aincr; }
     else Laser[index].l.d += Laser[index].l.bincr; 
     Laser[index].l.y += Laser[index].l.yincr;
   }
   else
   {
     if ( Laser[index].l.d >= 0 ) { Laser[index].l.y += Laser[index].l.yincr; Laser[index].l.d += Laser[index].l.aincr; }
     else Laser[index].l.d += Laser[index].l.bincr;
     Laser[index].l.x += Laser[index].l.xincr;
   }
}  
