//
// laser.h
//
void LaserInsert ( short ax, short ay, short owner )
{
  static short i;

  LaserAnz++;
  if ( LaserAnz >= LASERMAX ) { LaserAnz--; return; }

  Laser[LaserNextFree].free         = 1;
  Laser[LaserNextFree].ax           = ax;
  Laser[LaserNextFree].ay           = ay;
  Laser[LaserNextFree].dx           = Leute[owner].zx;
  Laser[LaserNextFree].dy           = Leute[owner].zy;
  Laser[LaserNextFree].length       = 7;
  Laser[LaserNextFree].speed        = 4;                                
  Laser[LaserNextFree].destruct     = Data[Leute[owner].type].destruct; 
  Laser[LaserNextFree].farbe        = 229;   
  Laser[LaserNextFree].owner        = owner;   
  
  InitLaser(LaserNextFree);
  
  for(i=LaserNextFree; i<LASERMAX; ++i) if ( !Laser[i].free ) { LaserNextFree = i; return; }
}



void InitLaser ( short index )
{
  if ( abs((Laser[index].dx-Laser[index].ax)) < abs((Laser[index].dy-Laser[index].ay)) )
  {
    if ( Laser[index].ay > Laser[index].dy )
    {
      Laser[index].l.yincr = -1;
      Laser[index].l.dy = Laser[index].ay - Laser[index].dy;                                      
    }
    else
    {
      Laser[index].l.yincr = 1;
      Laser[index].l.dy = Laser[index].dy - Laser[index].ay;
    }
    Laser[index].l.div = 1;

    if ( Laser[index].dx > Laser[index].ax ) Laser[index].l.xincr = 1;
    else Laser[index].l.xincr = -1;
    Laser[index].l.dx = abs( Laser[index].dx-Laser[index].ax );                                      // rel. X-Lnge
    Laser[index].l.d  = 2 * Laser[index].l.dx - Laser[index].l.dy;
    Laser[index].l.aincr = 2 * (Laser[index].l.dx - Laser[index].l.dy);
    Laser[index].l.bincr = 2 * Laser[index].l.dx;
    Laser[index].l.x = Laser[index].ax;
    Laser[index].l.y = Laser[index].ay;
  }
  else
  {
    if ( Laser[index].ax > Laser[index].dx )
    {
      Laser[index].l.xincr = -1;
      Laser[index].l.dx = Laser[index].ax - Laser[index].dx;
    }
    else
    {
      Laser[index].l.xincr = 1;
      Laser[index].l.dx = Laser[index].dx - Laser[index].ax;
    }

    Laser[index].l.div = 0;

    if ( Laser[index].dy > Laser[index].ay ) Laser[index].l.yincr = 1;
    else Laser[index].l.yincr = -1;
    Laser[index].l.dy = abs( Laser[index].dy-Laser[index].ay );
    Laser[index].l.d  = 2 * Laser[index].l.dy - Laser[index].l.dx;           
    Laser[index].l.aincr = 2 * (Laser[index].l.dy - Laser[index].l.dx);      
    Laser[index].l.bincr = 2 * Laser[index].l.dy;
    Laser[index].l.x = Laser[index].ax;
    Laser[index].l.y = Laser[index].ay;
  }
}


void LaserDelete ( short index )
{
  EAnz--;
  Laser[index].free = 0;

  if ( index < LaserNextFree ) LaserNextFree = index;
  Leute[Laser[index].owner].attack = 0;
  Leute[Laser[index].owner].who    = 255;
}


void LaserCompute ( short index )
{
  static short i, x, y;
  static LINE  puffer;
  static float f;

  y = x = f = 0;
  //------------------------------------------------------//
  if ( GameDel >= GameSpeed )
  {
    for(i=0; i<Laser[index].speed; i++) CalcLaserPoint(index);
  }
  memcpy(&puffer, &Laser[index].l, sizeof(LINE));

  for(i=0; i<Laser[index].length; i++,f+=0.5)
  {
    CalcLaserPoint(index);
    ssetpix(Laser[index].l.x-ScrollX, Laser[index].l.y-ScrollY, Laser[index].farbe-(byte)f);
  }

  memcpy(&Laser[index].l, &puffer, sizeof(LINE));
}


void CalcLaserPoint ( short index )
{
   if ( Laser[index].l.div  )
   {
     if ( Laser[index].l.d >= 0 ) { Laser[index].l.x += Laser[index].l.xincr; Laser[index].l.d += Laser[index].l.aincr; }
     else Laser[index].l.d += Laser[index].l.bincr; 
     Laser[index].l.y += Laser[index].l.yincr;
   }
   else
   {
     if ( Laser[index].l.d >= 0 ) { Laser[index].l.y += Laser[index].l.yincr; Laser[index].l.d += Laser[index].l.aincr; }
     else Laser[index].l.d += Laser[index].l.bincr;
     Laser[index].l.x += Laser[index].l.xincr;
   }  
}  
