//
// mann.h
//
#include "mann1.h"
#include "mann2.h"
#include "feind1.h"
#include "feind2.h"

/****************************************************************************/
/* "Erschafft" einen neuen Mann.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int MannInsert ( int ax, int ay, BYTE type )
{

  MannAnzahl++;
  if ( MannAnzahl > 199 ) { MannAnzahl--; return 1; }

  MannListe[MannAnzahl].type    = type;
  MannListe[MannAnzahl].del     = 0;
  MannListe[MannAnzahl].x       = ax-(f_x*20);
  MannListe[MannAnzahl].y       = ay-(f_y*20);
  MannListe[MannAnzahl].x1      = ax-(f_x*20);
  MannListe[MannAnzahl].y1      = ay-(f_y*20);
  MannListe[MannAnzahl].ax      = ax;
  MannListe[MannAnzahl].ay      = ay;
  MannListe[MannAnzahl].dx      = ax;
  MannListe[MannAnzahl].dy      = ay;
  MannListe[MannAnzahl].tx      = ax;
  MannListe[MannAnzahl].ty      = ay;
  MannListe[MannAnzahl].atkanz  = 0;
  MannListe[MannAnzahl].shape   = type*MANN_DIV;
  MannListe[MannAnzahl].energie = Data[type].energie;
  MannListe[MannAnzahl].attack  = 255;
  MannListe[MannAnzahl].stop    = 0;
  MannListe[MannAnzahl].fire    = 0;
  MannListe[MannAnzahl].status  = 0;
  MannListe[MannAnzahl].explose = 0;
  MannListe[MannAnzahl].feldx   = ax/Teilung;
  MannListe[MannAnzahl].feldy   = ay/Teilung;
  MannListe[MannAnzahl].dcount  = 0;
  AktListe[MannAnzahl]          = 0;

  return 1;
}

void MannDelete( BYTE index )
{
  int i;

  for ( i=index; i<MannAnzahl; i++ ) ML[i] = ML[i+1];     // index korrigieren
  memmove(&MannBack[index*400], &MannBack[(index+1)*400], (MannAnzahl-index)*400);
  MannAnzahl--;
}
  

/****************************************************************************/
/* "Erschafft" einen neuen Feind.                                           */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int FeindInsert ( int ax, int ay, BYTE type )
{

  FeindAnzahl++;
  if ( FeindAnzahl > 199 ) { FeindAnzahl--; return 1; }

  FL[FeindAnzahl].type    = type;
  FL[FeindAnzahl].del     = 0;
  FL[FeindAnzahl].x       = ax-(f_x*20);
  FL[FeindAnzahl].y       = ay-(f_y*20);
  FL[FeindAnzahl].x1      = ax-(f_x*20);
  FL[FeindAnzahl].y1      = ay-(f_y*20);
  FL[FeindAnzahl].ax      = ax;
  FL[FeindAnzahl].ay      = ay;
  FL[FeindAnzahl].dx      = ax;
  FL[FeindAnzahl].dy      = ay;
  FL[FeindAnzahl].tx      = ax/20;
  FL[FeindAnzahl].ty      = ay/20;
  FL[FeindAnzahl].atkanz  = 0;
  FL[FeindAnzahl].shape   = type*MANN_DIV;
  FL[FeindAnzahl].feldx   = ax/Teilung;
  FL[FeindAnzahl].feldy   = ay/Teilung;
  FL[FeindAnzahl].energie = Data[type].energie;
  FL[FeindAnzahl].explose = 0;
  FL[FeindAnzahl].stop    = 0;
  FL[FeindAnzahl].job     = 0;
  FL[FeindAnzahl].dcount  = 0;
  FL[FeindAnzahl].attack  = 255;

  return 1;
}

void FeindDelete( BYTE index )
{
  int i;

  for ( i=index; i<FeindAnzahl; i++ ) FL[i] = FL[i+1];
  memmove(&FeindBack[index*400], &FeindBack[(index+1)*400], (FeindAnzahl-index)*400);
  FeindAnzahl--;
}

void Mann_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x1+j)<Mrechts)&&((MLi.x1+j)>Mlinks)&&((MLi.y1+i)>Moben)&&((MLi.y1+i)<Munten) )
      {
        /*if ( MannBack[h] < 90 )*/ vsetpix(MLi.x1+j, MLi.y1+i, MannBack[h], res_x);
      }
      h++;
    }
  }
}

void Mann_set ( BYTE index )
{
  int i, j, h=index*400, k=MLi.shape*400, farbe=0;

  if ( MLi.status == 0 ) farbe = 254;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        MannBack[h] = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( (MannData[k]!=3)&&(MannBack[h]<90) )
        {
//          if ( MannData[k] == 0 ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
          vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}

void Feind_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FLi.x1+j)<Mrechts)&&((FLi.x1+j)>Mlinks)&&((FLi.y1+i)>Moben)&&((FLi.y1+i)<Munten) )
        vsetpix(FLi.x1+j, FLi.y1+i, FeindBack[h], res_x);
      h++;
    }
  }
}

void Feind_set ( BYTE index )
{
  int i, j, h=index*400, k=FLi.shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        FeindBack[h] = vgetpix( FLi.x+j, FLi.y+i, res_x);
        if ( (MannData[k]!=3)&&(FeindBack[h]<90) ) vsetpix( FLi.x+j, FLi.y+i, MannData[k], res_x); 
      }
    h++; k++;
    }
  }
}

void Mann_akt_set ( BYTE index )
{
  int i, j, h=index*400, k=MLi.shape*400, farbe=0;

  if ( MLi.status == 0 ) farbe = 254;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        MannBack[h] = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( ((MannData[k]!=3)&&(MannBack[h]<90)) )
        {
          //if ( MannData[k] == 0 ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
           vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
  //---------------------------- X-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254, res_x);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254, res_x);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254, res_x);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254, res_x);
  //---------------------------- Y-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254, res_x);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254, res_x);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254, res_x);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254, res_x);

}






























