//
// mann.h
//
#include "mann1.h"
#include "mann2.h"
#include "mann3.h"
#include "mannjp.h"
#include "feind1.h"
#include "feind2.h"
#include "feind3.h"
#include "feindjp.h"

int next_Mann_free=0, Max_Mann=-1;

/****************************************************************************/
/* "Erschafft" einen neuen Mann.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int MannInsert ( int ax, int ay, BYTE type )
{
  int i;

  if ( next_Mann_free > Max_Mann ) { MannAnzahl++; Max_Mann++; }
  if ( MannAnzahl > 199 ) { MannAnzahl--; Max_Mann--; return 1; }

  MannListe[next_Mann_free].type    = type;
  MannListe[next_Mann_free].free    = 1;
  MannListe[next_Mann_free].del     = 0;
  MannListe[next_Mann_free].x       = ax-(f_x*20);
  MannListe[next_Mann_free].y       = ay-(f_y*20);
  MannListe[next_Mann_free].x1      = ax-(f_x*20);
  MannListe[next_Mann_free].y1      = ay-(f_y*20);
  MannListe[next_Mann_free].ax      = ax;
  MannListe[next_Mann_free].ay      = ay;
  MannListe[next_Mann_free].dx      = ax;
  MannListe[next_Mann_free].dy      = ay;
  MannListe[next_Mann_free].tx      = ax;
  MannListe[next_Mann_free].ty      = ay;
  MannListe[next_Mann_free].atkanz  = 0;
  MannListe[next_Mann_free].shape   = (type+1)*MANN_DIV;
  MannListe[next_Mann_free].energie = Data[type].energie;
  MannListe[next_Mann_free].attack  = 255;
  MannListe[next_Mann_free].stop    = 0;
  MannListe[next_Mann_free].status  = 0;
  MannListe[next_Mann_free].fire    = 0;
  MannListe[next_Mann_free].rfire   = 0;
  MannListe[next_Mann_free].hit     = 0;
  MannListe[next_Mann_free].wasser  = 0;
  MannListe[next_Mann_free].status  = 0;
  MannListe[next_Mann_free].kills   = 0;
  MannListe[next_Mann_free].explose = 0;
  MannListe[next_Mann_free].feldx   = ax/Teilung;
  MannListe[next_Mann_free].feldy   = ay/Teilung;
  MannListe[next_Mann_free].dcount  = 0;
  MannListe[next_Mann_free].shape_anfang = 0;
  MannListe[next_Mann_free].on_text = 0;
  AktListe[next_Mann_free]          = 0;

  if ( type < 4 ) { ML[next_Mann_free].shape_x = 20; ML[next_Mann_free].shape_y = 20; }

  if ( type == 4 )
  {
     ML[next_Mann_free].shape_anfang = AP_ANFANG;   // Jagd-Panzer
     ML[next_Mann_free].shape_x = 34;
     ML[next_Mann_free].shape_y = 22;
     ML[next_Mann_free].shape = 5;
  }

  for(i=next_Mann_free; i<=Max_Mann+1; i++)
  {
      if ( !ML[i].free ) { next_Mann_free = i; break; }
  }
  return 1;
}

void MannDelete( BYTE index )
{
  MLi.free = 0; MLi.fire = 0; 
  if ( index < next_Mann_free ) next_Mann_free = index;
  if ( index == Max_Mann ) { MannAnzahl--; Max_Mann--; }
}
  

/****************************************************************************/
/* "Erschafft" einen neuen Feind.                                           */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int FeindInsert ( int ax, int ay, BYTE type )
{

  FeindAnzahl++;
  if ( FeindAnzahl > 199 ) { FeindAnzahl--; return 1; }

  FL[FeindAnzahl].type    = type;
  FL[FeindAnzahl].del     = 0;
  FL[FeindAnzahl].x       = ax-(f_x*20);
  FL[FeindAnzahl].y       = ay-(f_y*20);
  FL[FeindAnzahl].x1      = ax-(f_x*20);
  FL[FeindAnzahl].y1      = ay-(f_y*20);
  FL[FeindAnzahl].ax      = ax;
  FL[FeindAnzahl].ay      = ay;
  FL[FeindAnzahl].dx      = ax;
  FL[FeindAnzahl].dy      = ay;
  FL[FeindAnzahl].tx      = ax/20;
  FL[FeindAnzahl].ty      = ay/20;
  FL[FeindAnzahl].atkanz  = 0;
  FL[FeindAnzahl].shape   = type*MANN_DIV;
  FL[FeindAnzahl].feldx   = ax/Teilung;
  FL[FeindAnzahl].feldy   = ay/Teilung;
  FL[FeindAnzahl].energie = Data[type].energie;
  FL[FeindAnzahl].explose = 0;
  FL[FeindAnzahl].status  = 0;
  FL[FeindAnzahl].kills   = 0;
  FL[FeindAnzahl].wasser  = 0;
  FL[FeindAnzahl].hit     = 0;
  FL[FeindAnzahl].stop    = 0;
  FL[FeindAnzahl].job     = 0;
  FL[FeindAnzahl].dcount  = 0;
  FL[FeindAnzahl].attack  = 255;
  FL[FeindAnzahl].shape_anfang = 0;

  if ( type < 4 ) { FL[FeindAnzahl].shape_x = 20; FL[FeindAnzahl].shape_y = 20; }

  if ( type == 4 )
  {
     FL[FeindAnzahl].shape_anfang = APF_ANFANG;   // Jagd-Panzer
     FL[FeindAnzahl].shape_x = 34;
     FL[FeindAnzahl].shape_y = 22;
     FL[FeindAnzahl].shape = 5;
  }

  return 1;
}

void FeindDelete( BYTE index )
{
  int i;

  for ( i=index; i<FeindAnzahl; i++ ) FL[i] = FL[i+1];
  FeindAnzahl--;
}

void Mann_set ( BYTE index )
{
  int i, j, farbe =0;
  long k=MLi.shape_anfang+MLi.shape*(MLi.shape_x*MLi.shape_y);
  BYTE puffer;

  if ( MLi.status == 0 ) farbe = 242;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        if ( MannData[k] != 3 )
        {
          puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
          if ( puffer < 144 )
          {
            if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
            else vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
          }
        }
      }
      k++;
    }
  }
}


void Mann_white_set ( BYTE index )
{
  int i, j;
  long k=MLi.shape_anfang+MLi.shape*(MLi.shape_x*MLi.shape_y);
  BYTE puffer;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( (MannData[k]!=3)&&(puffer<144) ) vsetpix( MLi.x+j, MLi.y+i, 254, res_x);
      }
    h++; k++;
    }
  }

  MLi.hit = 0;
}

void Mann_wasser_set ( BYTE index )
{
  int i, j, farbe=0;
  long k=MLi.shape_anfang+MLi.shape*(MLi.shape_x*MLi.shape_y);
  BYTE puffer;

  if ( MLi.status == 0 ) farbe = 242;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<8; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( (MannData[k]>3)&&(puffer<144) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
          else vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}


void Feind_set ( BYTE index )
{
  int i, j, farbe= 0;
  long k=FLi.shape_anfang+FLi.shape*(FLi.shape_x*FLi.shape_y);
  BYTE puffer;

  if ( FLi.status == 0 ) farbe = 242;
  if ( FLi.status == 1 ) farbe = 253;
  if ( FLi.status == 2 ) farbe = 250;

  for ( i=0; i<FLi.shape_y; i++ )
  {
    for ( j=0; j<FLi.shape_x; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        puffer = vgetpix( FLi.x+j, FLi.y+i, res_x);
        if ( (MannData[k]>3)&&(puffer<144) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( FLi.x+j, FLi.y+i, farbe, res_x);
          else vsetpix( FLi.x+j, FLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}

void Feind_wasser_set ( BYTE index )
{
  int i, j, farbe= 0;
  long k=FLi.shape_anfang+FLi.shape*(FLi.shape_x*FLi.shape_y);
  BYTE puffer;

  if ( FLi.status == 0 ) farbe = 242;
  if ( FLi.status == 1 ) farbe = 253;
  if ( FLi.status == 2 ) farbe = 250;

  for ( i=0; i<8; i++ )
  {
    for ( j=0; j<FLi.shape_x; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        puffer = vgetpix( FLi.x+j, FLi.y+i, res_x);
        if ( (MannData[k]>3)&&(puffer<144) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( FLi.x+j, FLi.y+i, farbe, res_x);
          else vsetpix( FLi.x+j, FLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}



void Feind_white_set ( BYTE index )
{
  int i, j;
  long k=FLi.shape_anfang+FLi.shape*(FLi.shape_x*FLi.shape_y);
  BYTE puffer;

  for ( i=0; i<FLi.shape_y; i++ )
  {
    for ( j=0; j<FLi.shape_x; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        puffer = vgetpix( FLi.x+j, FLi.y+i, res_x);
        if ( (MannData[k]>3)&&(puffer<144) ) vsetpix( FLi.x+j, FLi.y+i, 254, res_x);
      }
    h++; k++;
    }
  }

  FLi.hit = 0;
}



void Mann_akt_set ( BYTE index )
{
  int i, j, farbe=0;
  long k=MLi.shape_anfang+MLi.shape*(MLi.shape_x*MLi.shape_y);
  BYTE puffer;

  if ( MLi.status == 0 ) farbe = 242;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        if ( MannData[k] != 3 )
        {
          puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
          if ( puffer < 144 )
          {
            if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
            else vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
          }
        }
      }
    h++; k++;
    }
  }
  //---------------------------- X-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254, res_x);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254, res_x);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254, res_x);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254, res_x);
  //---------------------------- Y-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254, res_x);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254, res_x);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254, res_x);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254, res_x);
}

void Mann_white_akt_set ( BYTE index )
{
  int i, j;
  long k=MLi.shape_anfang+MLi.shape*(MLi.shape_x*MLi.shape_y);
  BYTE puffer;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( ((MannData[k]>3)&&(puffer<144)) ) vsetpix( MLi.x+j, MLi.y+i, 254, res_x);
      }
    h++; k++;
    }
  }
  //---------------------------- X-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254, res_x);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254, res_x);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254, res_x);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254, res_x);
  //---------------------------- Y-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254, res_x);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254, res_x);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254, res_x);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254, res_x);


  MLi.hit = 0;
}





























