//
// mann.h
//
#include "mann1.h"
#include "mann2.h"
#include "mann3.h"
#include "feind1.h"
#include "feind2.h"
#include "feind3.h"


/****************************************************************************/
/* "Erschafft" einen neuen Mann.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int MannInsert ( int ax, int ay, BYTE type )
{

  MannAnzahl++;
  if ( MannAnzahl > 199 ) { MannAnzahl--; return 1; }

  MannListe[MannAnzahl].type    = type;
  MannListe[MannAnzahl].del     = 0;
  MannListe[MannAnzahl].x       = ax-(f_x*20);
  MannListe[MannAnzahl].y       = ay-(f_y*20);
  MannListe[MannAnzahl].x1      = ax-(f_x*20);
  MannListe[MannAnzahl].y1      = ay-(f_y*20);
  MannListe[MannAnzahl].ax      = ax;
  MannListe[MannAnzahl].ay      = ay;
  MannListe[MannAnzahl].dx      = ax;
  MannListe[MannAnzahl].dy      = ay;
  MannListe[MannAnzahl].tx      = ax;
  MannListe[MannAnzahl].ty      = ay;
  MannListe[MannAnzahl].atkanz  = 0;
  MannListe[MannAnzahl].shape   = (type+1)*MANN_DIV;
  MannListe[MannAnzahl].energie = Data[type].energie;
  MannListe[MannAnzahl].attack  = 255;
  MannListe[MannAnzahl].stop    = 0;
  MannListe[MannAnzahl].status  = 0;
  MannListe[MannAnzahl].fire    = 0;
  MannListe[MannAnzahl].rfire   = 0;
  MannListe[MannAnzahl].hit     = 0;
  MannListe[MannAnzahl].wasser  = 0;
  MannListe[MannAnzahl].status  = 0;
  MannListe[MannAnzahl].kills   = 0;
  MannListe[MannAnzahl].explose = 0;
  MannListe[MannAnzahl].feldx   = ax/Teilung;
  MannListe[MannAnzahl].feldy   = ay/Teilung;
  MannListe[MannAnzahl].dcount  = 0;
  AktListe[MannAnzahl]          = 0;

  if ( type < 4 ) { ML[MannAnzahl].shape_x = 20; ML[MannAnzahl].shape_y = 20; }
  if ( type == 1 ) { ML[MannAnzahl].shape_x = 20; ML[MannAnzahl].shape_y = 20; }


  return 1;
}

void MannDelete( BYTE index )
{
  int i;

  for ( i=index; i<MannAnzahl; i++ ) { ML[i] = ML[i+1]; AktListe[i] = AktListe[i+1]; }    // index korrigieren
  MannAnzahl--;
}
  

/****************************************************************************/
/* "Erschafft" einen neuen Feind.                                           */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int FeindInsert ( int ax, int ay, BYTE type )
{

  FeindAnzahl++;
  if ( FeindAnzahl > 199 ) { FeindAnzahl--; return 1; }

  FL[FeindAnzahl].type    = type;
  FL[FeindAnzahl].del     = 0;
  FL[FeindAnzahl].x       = ax-(f_x*20);
  FL[FeindAnzahl].y       = ay-(f_y*20);
  FL[FeindAnzahl].x1      = ax-(f_x*20);
  FL[FeindAnzahl].y1      = ay-(f_y*20);
  FL[FeindAnzahl].ax      = ax;
  FL[FeindAnzahl].ay      = ay;
  FL[FeindAnzahl].dx      = ax;
  FL[FeindAnzahl].dy      = ay;
  FL[FeindAnzahl].tx      = ax/20;
  FL[FeindAnzahl].ty      = ay/20;
  FL[FeindAnzahl].atkanz  = 0;
  FL[FeindAnzahl].shape   = type*MANN_DIV;
  FL[FeindAnzahl].feldx   = ax/Teilung;
  FL[FeindAnzahl].feldy   = ay/Teilung;
  FL[FeindAnzahl].energie = Data[type].energie;
  FL[FeindAnzahl].explose = 0;
  FL[FeindAnzahl].status  = 0;
  FL[FeindAnzahl].kills   = 0;
  FL[FeindAnzahl].wasser  = 0;
  FL[FeindAnzahl].hit     = 0;
  FL[FeindAnzahl].stop    = 0;
  FL[FeindAnzahl].job     = 0;
  FL[FeindAnzahl].dcount  = 0;
  FL[FeindAnzahl].attack  = 255;

  if ( type < 4 ) { FL[FeindAnzahl].shape_x = 20; FL[FeindAnzahl].shape_y = 20; }
  if ( type == 1 ) { FL[FeindAnzahl].shape_x = 20; FL[FeindAnzahl].shape_y = 20; }


  return 1;
}

void FeindDelete( BYTE index )
{
  int i;

  for ( i=index; i<FeindAnzahl; i++ ) FL[i] = FL[i+1];
  FeindAnzahl--;
}

void Mann_set ( BYTE index )
{
  int i, j, k=MLi.shape*400, farbe=0;
  BYTE puffer;

  if ( MLi.status == 0 ) farbe = 242;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( (MannData[k]!=3)&&(puffer<144) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
          else vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}


void Mann_white_set ( BYTE index )
{
  int i, j, k=MLi.shape*400;
  BYTE puffer;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( (MannData[k]!=3)&&(puffer<144) ) vsetpix( MLi.x+j, MLi.y+i, 254, res_x);
      }
    h++; k++;
    }
  }

  MLi.hit = 0;
}

void Mann_wasser_set ( BYTE index )
{
  int i, j, k=MLi.shape*400, farbe=0;
  BYTE puffer;

  if ( MLi.status == 0 ) farbe = 242;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<8; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( (MannData[k]!=3)&&(puffer<144) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
          else vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}


void Feind_set ( BYTE index )
{
  int i, j, k=FLi.shape*400, farbe= 0;
  BYTE puffer;

  if ( FLi.status == 0 ) farbe = 242;
  if ( FLi.status == 1 ) farbe = 253;
  if ( FLi.status == 2 ) farbe = 250;

  for ( i=0; i<FLi.shape_y; i++ )
  {
    for ( j=0; j<FLi.shape_x; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        puffer = vgetpix( FLi.x+j, FLi.y+i, res_x);
        if ( (MannData[k]!=3)&&(puffer<144) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( FLi.x+j, FLi.y+i, farbe, res_x);
          else vsetpix( FLi.x+j, FLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}

void Feind_wasser_set ( BYTE index )
{
  int i, j, k=FLi.shape*400, farbe= 0;
  BYTE puffer;

  if ( FLi.status == 0 ) farbe = 242;
  if ( FLi.status == 1 ) farbe = 253;
  if ( FLi.status == 2 ) farbe = 250;

  for ( i=0; i<8; i++ )
  {
    for ( j=0; j<FLi.shape_x; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        puffer = vgetpix( FLi.x+j, FLi.y+i, res_x);
        if ( (MannData[k]!=3)&&(puffer<144) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( FLi.x+j, FLi.y+i, farbe, res_x);
          else vsetpix( FLi.x+j, FLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}



void Feind_white_set ( BYTE index )
{
  int i, j, k=FLi.shape*400;
  BYTE puffer;

  for ( i=0; i<FLi.shape_y; i++ )
  {
    for ( j=0; j<FLi.shape_x; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        puffer = vgetpix( FLi.x+j, FLi.y+i, res_x);
        if ( (MannData[k]!=3)&&(puffer<144) ) vsetpix( FLi.x+j, FLi.y+i, 254, res_x);
      }
    h++; k++;
    }
  }

  FLi.hit = 0;
}



void Mann_akt_set ( BYTE index )
{
  int i, j, k=MLi.shape*400, farbe=0;
  BYTE puffer;

  if ( MLi.status == 0 ) farbe = 242;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( ((MannData[k]!=3)&&(puffer<144)) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
          else vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
  //---------------------------- X-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254, res_x);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254, res_x);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254, res_x);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254, res_x);
  //---------------------------- Y-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254, res_x);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254, res_x);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254, res_x);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254, res_x);
}

void Mann_white_akt_set ( BYTE index )
{
  int i, j, k=MLi.shape*400;
  BYTE puffer;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( ((MannData[k]!=3)&&(puffer<144)) ) vsetpix( MLi.x+j, MLi.y+i, 254, res_x);
      }
    h++; k++;
    }
  }
  //---------------------------- X-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254, res_x);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254, res_x);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254, res_x);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254, res_x);
  //---------------------------- Y-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254, res_x);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254, res_x);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254, res_x);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254, res_x);


  MLi.hit = 0;
}





























