//
// mann.h
//
#include "mann1.h"
#include "mann2.h"
#include "mann3.h"
#include "mannjp.h"
#include "feind1.h"
#include "feind2.h"
#include "feind3.h"
#include "feindjp.h"

int next_Mann_free=0, Max_Mann=-1;
int next_Feind_free=0, Max_Feind=-1;

/****************************************************************************/
/* "Erschafft" einen neuen Mann.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int MannInsert ( int ax, int ay, BYTE type )
{
  int i;

  if ( next_Mann_free > Max_Mann ) Max_Mann++; 
  if ( Max_Mann > LEUTE-1 ) return 1; 

  MannListe[next_Mann_free].type    = type;
  MannListe[next_Mann_free].free    = 1;
  MannListe[next_Mann_free].del     = 0;
  MannListe[next_Mann_free].x       = ax-(f_x*20);
  MannListe[next_Mann_free].y       = ay-(f_y*20);
  MannListe[next_Mann_free].x1      = ax-(f_x*20);
  MannListe[next_Mann_free].y1      = ay-(f_y*20);
  MannListe[next_Mann_free].ax      = ax;
  MannListe[next_Mann_free].ay      = ay;
  MannListe[next_Mann_free].dx      = ax;
  MannListe[next_Mann_free].dy      = ay;
  MannListe[next_Mann_free].tx      = ax;
  MannListe[next_Mann_free].ty      = ay;
  MannListe[next_Mann_free].atkanz  = 0;
  MannListe[next_Mann_free].shape   = (type+1)*MANN_DIV;
  MannListe[next_Mann_free].energie = Data[type].energie;
  MannListe[next_Mann_free].attack  = 255;
  MannListe[next_Mann_free].stop    = 0;
  MannListe[next_Mann_free].status  = 0;
  MannListe[next_Mann_free].fire    = 0;
  MannListe[next_Mann_free].rfire   = 0;
  MannListe[next_Mann_free].hit     = 0;
  MannListe[next_Mann_free].wasser  = 0;
  MannListe[next_Mann_free].status  = 0;
  MannListe[next_Mann_free].kills   = 0;
  MannListe[next_Mann_free].explose = 0;
  MannListe[next_Mann_free].feldx   = ax/Teilung;
  MannListe[next_Mann_free].feldy   = ay/Teilung;
  MannListe[next_Mann_free].dcount  = 0;
  MannListe[next_Mann_free].shape_anfang = 0;
  MannListe[next_Mann_free].on_text = 0;
  AktListe[next_Mann_free]          = 0;

  if ( type < 4 ) { ML[next_Mann_free].shape_x = 20; ML[next_Mann_free].shape_y = 20; }

  if ( type == 4 )
  {
     ML[next_Mann_free].shape_anfang = AP_ANFANG;   // Jagd-Panzer
     ML[next_Mann_free].shape_x = 34;
     ML[next_Mann_free].shape_y = 22;
     ML[next_Mann_free].shape = 5;
  }

  for(i=0; i<=Max_Mann+1; i++)
  {
      if ( !ML[i].free ) { next_Mann_free = i; return 1; }
  }
  return 1;
}

void MannDelete( BYTE index )
{
  MLi.free = 0; MLi.fire = 0; 
  if ( index < next_Mann_free ) next_Mann_free = index;
  if ( index >= Max_Mann ) Max_Mann--;
}
  

/****************************************************************************/
/* "Erschafft" einen neuen Feind.                                           */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int FeindInsert ( int ax, int ay, BYTE type )
{
  int i;

  if ( next_Feind_free > Max_Feind ) Max_Feind++;
  if ( Max_Feind > LEUTE-1 ) return 1; 

  FL[next_Feind_free].type    = type;
  FL[next_Feind_free].free    = 1;
  FL[next_Feind_free].del     = 0;
  FL[next_Feind_free].x       = ax-(f_x*20);
  FL[next_Feind_free].y       = ay-(f_y*20);
  FL[next_Feind_free].x1      = ax-(f_x*20);
  FL[next_Feind_free].y1      = ay-(f_y*20);
  FL[next_Feind_free].ax      = ax;
  FL[next_Feind_free].ay      = ay;
  FL[next_Feind_free].dx      = ax;
  FL[next_Feind_free].dy      = ay;
  FL[next_Feind_free].tx      = ax/20;
  FL[next_Feind_free].ty      = ay/20;
  FL[next_Feind_free].atkanz  = 0;
  FL[next_Feind_free].shape   = type*MANN_DIV;
  FL[next_Feind_free].feldx   = ax/Teilung;
  FL[next_Feind_free].feldy   = ay/Teilung;
  FL[next_Feind_free].energie = Data[type].energie;
  FL[next_Feind_free].explose = 0;
  FL[next_Feind_free].status  = 0;
  FL[next_Feind_free].kills   = 0;
  FL[next_Feind_free].wasser  = 0;
  FL[next_Feind_free].hit     = 0;
  FL[next_Feind_free].stop    = 0;
  FL[next_Feind_free].job     = 0;
  FL[next_Feind_free].dcount  = 0;
  FL[next_Feind_free].attack  = 255;
  FL[next_Feind_free].shape_anfang = 0;

  if ( type < 4 ) { FL[next_Feind_free].shape_x = 20; FL[next_Feind_free].shape_y = 20; }

  if ( type == 4 )
  {
     FL[next_Feind_free].shape_anfang = APF_ANFANG;   // Jagd-Panzer
     FL[next_Feind_free].shape_x = 34;
     FL[next_Feind_free].shape_y = 22;
     FL[next_Feind_free].shape = 5;
  }

  for(i=0; i<=Max_Feind+1; i++)
  {
      if ( !FL[i].free ) { next_Feind_free = i; return 1; }
  }
  return 1;
}

void FeindDelete( BYTE index )
{
  FLi.free = 0; FLi.fire = 0; 
  if ( index < next_Feind_free ) next_Feind_free = index;
  if ( index >= Max_Feind ) Max_Feind--; 
}


void Mann_set ( BYTE index )
{
  int i, j, farbe =0;
  long k=MLi.shape_anfang+MLi.shape*(MLi.shape_x*MLi.shape_y);
  BYTE puffer;

  if ( MLi.status == 0 ) farbe = 242;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        if ( MannData[k] != 3 )
        {
          puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
          if ( puffer < 144 )
          {
            if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
            else vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
          }
        }
      }
      k++;
    }
  }
}


void Mann_white_set ( BYTE index )
{
  int i, j;
  long k=MLi.shape_anfang+MLi.shape*(MLi.shape_x*MLi.shape_y);
  BYTE puffer;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( (MannData[k]!=3)&&(puffer<144) ) vsetpix( MLi.x+j, MLi.y+i, 254, res_x);
      }
    h++; k++;
    }
  }

  MLi.hit = 0;
}

void Mann_wasser_set ( BYTE index )
{
  int i, j, farbe=0;
  long k=MLi.shape_anfang+MLi.shape*(MLi.shape_x*MLi.shape_y);
  BYTE puffer;

  if ( MLi.status == 0 ) farbe = 242;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<8; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( (MannData[k]>3)&&(puffer<144) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
          else vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}


void Feind_set ( BYTE index )
{
  int i, j, farbe= 0;
  long k=FLi.shape_anfang+FLi.shape*(FLi.shape_x*FLi.shape_y);
  BYTE puffer;

  if ( FLi.status == 0 ) farbe = 242;
  if ( FLi.status == 1 ) farbe = 253;
  if ( FLi.status == 2 ) farbe = 250;

  for ( i=0; i<FLi.shape_y; i++ )
  {
    for ( j=0; j<FLi.shape_x; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        puffer = vgetpix( FLi.x+j, FLi.y+i, res_x);
        if ( (MannData[k]>3)&&(puffer<144) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( FLi.x+j, FLi.y+i, farbe, res_x);
          else vsetpix( FLi.x+j, FLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}

void Feind_wasser_set ( BYTE index )
{
  int i, j, farbe= 0;
  long k=FLi.shape_anfang+FLi.shape*(FLi.shape_x*FLi.shape_y);
  BYTE puffer;

  if ( FLi.status == 0 ) farbe = 242;
  if ( FLi.status == 1 ) farbe = 253;
  if ( FLi.status == 2 ) farbe = 250;

  for ( i=0; i<8; i++ )
  {
    for ( j=0; j<FLi.shape_x; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        puffer = vgetpix( FLi.x+j, FLi.y+i, res_x);
        if ( (MannData[k]>3)&&(puffer<144) )
        {
          if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( FLi.x+j, FLi.y+i, farbe, res_x);
          else vsetpix( FLi.x+j, FLi.y+i, MannData[k], res_x);
        }
      }
    h++; k++;
    }
  }
}



void Feind_white_set ( BYTE index )
{
  int i, j;
  long k=FLi.shape_anfang+FLi.shape*(FLi.shape_x*FLi.shape_y);
  BYTE puffer;

  for ( i=0; i<FLi.shape_y; i++ )
  {
    for ( j=0; j<FLi.shape_x; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        puffer = vgetpix( FLi.x+j, FLi.y+i, res_x);
        if ( (MannData[k]>3)&&(puffer<144) ) vsetpix( FLi.x+j, FLi.y+i, 254, res_x);
      }
    h++; k++;
    }
  }

  FLi.hit = 0;
}



void Mann_akt_set ( BYTE index )
{
  int i, j, farbe=0;
  long k=MLi.shape_anfang+MLi.shape*(MLi.shape_x*MLi.shape_y);
  BYTE puffer;

  if ( MLi.status == 0 ) farbe = 242;
  if ( MLi.status == 1 ) farbe = 253;
  if ( MLi.status == 2 ) farbe = 250;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        if ( MannData[k] != 3 )
        {
          puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
          if ( puffer < 144 )
          {
            if ( (MannData[k] == 0)||(MannData[k] == 255) ) vsetpix( MLi.x+j, MLi.y+i, farbe, res_x);
            else vsetpix( MLi.x+j, MLi.y+i, MannData[k], res_x);
          }
        }
      }
    h++; k++;
    }
  }
  k = MLi.shape_x/2; farbe = MLi.shape_x/4;
  j = (MLi.energie * k) / Data[MLi.type].energie;
  for(i=farbe; i<farbe+j; i++)
  {
    if ( (MLi.y-3<Munten)&&(MLi.y-3>Moben)&&(MLi.x+i>Mlinks)&&(MLi.x+i<Mrechts) ) vsetpix(MLi.x+i, MLi.y-3, 253, res_x);
    if ( (MLi.y-2<Munten)&&(MLi.y-2>Moben)&&(MLi.x+i>Mlinks)&&(MLi.x+i<Mrechts) ) vsetpix(MLi.x+i, MLi.y-2, 253, res_x);
  }
  for(i=farbe; i<farbe+k+1; i++)
  {
    if ( (MLi.y-1<Munten)&&(MLi.y-1>Moben)&&(MLi.x+i>Mlinks)&&(MLi.x+i<Mrechts) ) vsetpix(MLi.x+i, MLi.y-1, 255, res_x);
    if ( (MLi.y-4<Munten)&&(MLi.y-4>Moben)&&(MLi.x+i>Mlinks)&&(MLi.x+i<Mrechts) ) vsetpix(MLi.x+i, MLi.y-4, 255, res_x);
  }

  if ( (MLi.y-1<Munten)&&(MLi.y-1>Moben)&&(MLi.x+farbe-1>Mlinks)&&(MLi.x+farbe-1<Mrechts) ) vsetpix(MLi.x+farbe-1, MLi.y-1, 255, res_x);
  if ( (MLi.y-2<Munten)&&(MLi.y-2>Moben)&&(MLi.x+farbe-1>Mlinks)&&(MLi.x+farbe-1<Mrechts) ) vsetpix(MLi.x+farbe-1, MLi.y-2, 255, res_x);
  if ( (MLi.y-3<Munten)&&(MLi.y-3>Moben)&&(MLi.x+farbe-1>Mlinks)&&(MLi.x+farbe-1<Mrechts) ) vsetpix(MLi.x+farbe-1, MLi.y-3, 255, res_x);
  if ( (MLi.y-4<Munten)&&(MLi.y-4>Moben)&&(MLi.x+farbe-1>Mlinks)&&(MLi.x+farbe-1<Mrechts) ) vsetpix(MLi.x+farbe-1, MLi.y-4, 255, res_x);
  //------------------------------------------------------------------------//
  if ( (MLi.y-2<Munten)&&(MLi.y-2>Moben)&&(MLi.x+farbe+k>Mlinks)&&(MLi.x+farbe+k<Mrechts) ) vsetpix(MLi.x+farbe+k, MLi.y-2, 255, res_x);
  if ( (MLi.y-3<Munten)&&(MLi.y-3>Moben)&&(MLi.x+farbe+k>Mlinks)&&(MLi.x+farbe+k<Mrechts) ) vsetpix(MLi.x+farbe+k, MLi.y-3, 255, res_x);
 
}

void Mann_white_akt_set ( BYTE index )
{
  int i, j, farbe;
  long k=MLi.shape_anfang+MLi.shape*(MLi.shape_x*MLi.shape_y);
  BYTE puffer;

  for ( i=0; i<MLi.shape_y; i++ )
  {
    for ( j=0; j<MLi.shape_x; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        puffer = vgetpix( MLi.x+j, MLi.y+i, res_x);
        if ( ((MannData[k]>3)&&(puffer<144)) ) vsetpix( MLi.x+j, MLi.y+i, 254, res_x);
      }
    h++; k++;
    }
  }
  k = MLi.shape_x/2; farbe = MLi.shape_x/4;
  j = (MLi.energie * k) / Data[MLi.type].energie;
  for(i=farbe; i<farbe+j; i++)
  {
    if ( (MLi.y-3<Munten)&&(MLi.y-3>Moben)&&(MLi.x+i>Mlinks)&&(MLi.x+i<Mrechts) ) vsetpix(MLi.x+i, MLi.y-3, 253, res_x);
    if ( (MLi.y-2<Munten)&&(MLi.y-2>Moben)&&(MLi.x+i>Mlinks)&&(MLi.x+i<Mrechts) ) vsetpix(MLi.x+i, MLi.y-2, 253, res_x);
  }
  for(i=farbe; i<farbe+k+1; i++)
  {
    if ( (MLi.y-1<Munten)&&(MLi.y-1>Moben)&&(MLi.x+i>Mlinks)&&(MLi.x+i<Mrechts) ) vsetpix(MLi.x+i, MLi.y-1, 241, res_x);
    if ( (MLi.y-4<Munten)&&(MLi.y-4>Moben)&&(MLi.x+i>Mlinks)&&(MLi.x+i<Mrechts) ) vsetpix(MLi.x+i, MLi.y-4, 241, res_x);
  }

  if ( (MLi.y-1<Munten)&&(MLi.y-1>Moben)&&(MLi.x+farbe-1>Mlinks)&&(MLi.x+farbe-1<Mrechts) ) vsetpix(MLi.x+farbe-1, MLi.y-1, 241, res_x);
  if ( (MLi.y-2<Munten)&&(MLi.y-2>Moben)&&(MLi.x+farbe-1>Mlinks)&&(MLi.x+farbe-1<Mrechts) ) vsetpix(MLi.x+farbe-1, MLi.y-2, 241, res_x);
  if ( (MLi.y-3<Munten)&&(MLi.y-3>Moben)&&(MLi.x+farbe-1>Mlinks)&&(MLi.x+farbe-1<Mrechts) ) vsetpix(MLi.x+farbe-1, MLi.y-3, 241, res_x);
  if ( (MLi.y-4<Munten)&&(MLi.y-4>Moben)&&(MLi.x+farbe-1>Mlinks)&&(MLi.x+farbe-1<Mrechts) ) vsetpix(MLi.x+farbe-1, MLi.y-4, 241, res_x);
  //------------------------------------------------------------------------//
  if ( (MLi.y-2<Munten)&&(MLi.y-2>Moben)&&(MLi.x+farbe+k>Mlinks)&&(MLi.x+farbe+k<Mrechts) ) vsetpix(MLi.x+farbe+k, MLi.y-2, 241, res_x);
  if ( (MLi.y-3<Munten)&&(MLi.y-3>Moben)&&(MLi.x+farbe+k>Mlinks)&&(MLi.x+farbe+k<Mrechts) ) vsetpix(MLi.x+farbe+k, MLi.y-3, 241, res_x);

  MLi.hit = 0;
}





























