//
// mouse.h
//
#define MouseLeftUp     4
#define MouseLeftDown   2
#define MouseRightUp    16
#define MouseRightDown  8
#define MouseMove       1
#define MouseCtrl       64
#define m_save  0
#define m_image 1
#define m_up    3
#define m_down  4
#define m_left  2
#define m_right 5
#define m_franz 6

byte m_images[30][256], m_show_image=1;
short mx1=0, my1=0, mx=0, my=0;

struct callback_data
{
    int right_button;
    int mouse_event;
    unsigned short mouse_code;
    unsigned short mouse_bx;
    unsigned short MouseX;
    unsigned short MouseY;
    signed short mouse_si;
    signed short mouse_di;
} cbd = { 0 };

int lock_region (void *address, unsigned length)
{
    union REGS regs;
    unsigned linear;

    linear = (unsigned) address;

    regs.w.ax = 0x600;			/* DPMI Lock Linear Region */
    regs.w.bx = (unsigned short) (linear >> 16); /* Linear address in BX:CX */
    regs.w.cx = (unsigned short) (linear & 0xFFFF);
    regs.w.si = (unsigned short) (length >> 16); /* Length in SI:DI */
    regs.w.di = (unsigned short) (length & 0xFFFF);
    int386 (0x31, &regs, &regs);
    return (! regs.w.cflag);		/* Return 0 if can't lock */
}

#pragma off (check_stack)
void _loadds far click_handler (int max, int mbx, int mcx, int mdx,
				int msi, int mdi)
{
#pragma aux click_handler parm [EAX] [EBX] [ECX] [EDX] [ESI] [EDI]
    cbd.mouse_event = 1;

    cbd.mouse_code = (unsigned short) max;
    cbd.MouseX = (unsigned short) mcx;
    cbd.MouseY = (unsigned short) mdx;

    if ( cbd.mouse_code != 0 ) MouseMoved = 1;
    cbd.mouse_code = cbd.mouse_code & 0xFFFE;

    if ( my > ResY ) my = ResY;
    if ( mx > ResX ) mx = ResX;
}

void cbc_end (void) 
{                   
}                   
#pragma on (check_stack)

void InstallMouseHandler ( void )
{
    struct SREGS sregs;
    union REGS inregs, outregs;
    int installed = 0;
    unsigned short far *ptr;
    void (far *function_ptr)();

    segread(&sregs);

    /* check for mouse driver */

    inregs.w.ax = 0;
    int386 (0x33, &inregs, &outregs);
    if( installed = (outregs.w.ax == 0xffff) ) ;
    else
    {
      printf("\n\nERROR: Es wurde keine Maus gefunden!\n");
      exit(0);
    }

    if ( (! lock_region (&cbd, sizeof(cbd))) || (! lock_region ((void near *) click_handler,
         (char *) cbc_end - (char near *) click_handler)))
    {
       printf("\n\nERROR: Konnte MausHandler nicht installieren!\n" );
       exit(0);
    }
    else
    {
      inregs.w.ax = 0x1;
      int386 (0x33, &inregs, &outregs);

      /* install click watcher */
      inregs.w.ax = 0xC;
      inregs.w.cx = 1 + 2 + 4 + 8 + 16 + 64;              
      function_ptr = ( void(*)(void) ) click_handler;
      inregs.x.edx = FP_OFF (function_ptr);
      sregs.es     = FP_SEG (function_ptr);
      int386x (0x33, &inregs, &outregs, &sregs);
    }

}

void UnInstallMouseHandler ( void )
{
    union REGS inregs, outregs;

    inregs.w.ax = 0;
    int386 (0x33, &inregs, &outregs);
    if (outregs.w.ax != 0xffff) printf("\nMausHandler konnte nicht entfernt werden!\n");
}


int maus_innen ( short x, short y, short x1, short y1 )
{
  if ( (mx>x-1)&&(mx<x1+1)&&(my>y-1)&&(my<y1+1) ) return 1;
  else return 0;
}

void MouseBackRestore ( void )
{
  short i, j, h= 0;

  for ( i=0; i<16; i++ )
  {
    for ( j=0; j<16; j++ )
    {
      ssetpix(mx1+j, my1+i, m_images[m_save][h]);
      h++;
    }
  }
}


void MouseBackSave ( void )
{
  short i, j, h= 0;

  for ( i=0; i<16; i++ )
  {
    for ( j=0; j<16; j++ )
    {
      m_images[m_save][h] = getpix(mx+j, my+i);
      h++;
    }
  }
}

void MousePlace ( void )
{
  short i, j, h= 0;

  for ( i=0; i<16; i++ )
  {
    for ( j=0; j<16; j++ )
    {
      if ( m_images[m_show_image][h] != 0 )
      {
        ssetpix(mx+j, my+i, m_images[m_show_image][h]);
      }
      h++;
    }
  }
}

void MouseLoadImages ( void )
{
  FILE *Datei;
  short i=0, Zeichen;
  char *ptr;

  chdir("RESOURCE");

  if ( (Datei = fopen("maus.rsc", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'maus.rsc' nicht laden!\n\n");
    exit(0);
  }
  i=256; ptr = m_images;
  while ((Zeichen = fgetc(Datei)) != EOF) ptr[i++] = (byte)Zeichen; 
  fclose(Datei);

  chdir("..");
}


int MouseReset( void )
{
  regs.x.eax = 0x0000;               
  int386( 0x33, &regs, &regs );

  if ( regs.x.eax == 0xFFFF ) return 0;
  return 1;
}

void MousePut ( int x, int y )
{
  mx1= mx= x; my1= my= y;

  regs.x.eax = 0x0004;               
  regs.x.ecx = x;
  regs.x.edx = y;
  int386( 0x33, &regs, &regs );
}

























void MouseRight ( void )
{
   short i;

   Scrolled = 0;

   if ( (cbd.mouse_code == MouseRightDown)&&(!RightScroll) )
   {
     RightScroll = 1;
     RightScrollX = mx;
     RightScrollY = my;
   }
   if ( RightScroll )
   {
     if ( (mx < RightScrollX)&&(ScrollX > 0) )                  { ScrollLeft();  NachScroll=RightScrollX-mx; ScrollDir=1; Scrolled=1; }
     if ( (mx > RightScrollX)&&(ScrollX < (FeldX*20)-ResX) )    { ScrollRight(); NachScroll=mx-RightScrollX; ScrollDir=2; Scrolled=1; }
     if ( (my < RightScrollY)&&(ScrollY > 0) )                  { ScrollUp();    NachScroll=RightScrollY-my; ScrollDir=3; Scrolled=1; }
     if ( (my > RightScrollY)&&(ScrollY < (FeldY*20)-ResY-20) ) { ScrollDown();  NachScroll=my-RightScrollY; ScrollDir=4; Scrolled=1; }
     RightScrollX = mx; RightScrollY = my;
   }
   if ( (cbd.mouse_code == MouseRightUp) )
   {
     if ( RightScrolled != 2 )
     {
       for(i=0; i<LMAX; i++) if ( Leute[i].aktive ) Leute[i].aktive = 0;
     }
     MouseSetNorm();
     RightScroll = RightScrolled = 0;
     MouseDelete = 1;
   }
}


void MouseLeft ( void )
{
   static short i, j, x, mx1, y, my1;


   if ( (cbd.mouse_code == MouseLeftDown) )
   {
     if (!Rahmen) { Rahmen = 1; RahmenX = mx; RahmenY = my; }
   }
   if ( ((RahmenX!=mx)||(RahmenY!=my))&&(Rahmen==1) )
   {
     Rahmen = 2;
   }

//==========================================================================//
   if ( cbd.mouse_code == MouseLeftUp )
   {
     for(i=0; i<LMAX; i++)
     {
       // Zeigt der Mauszeiger auf eine Einheit //
       if ( maus_innen(Leute[i].x-5, Leute[i].y-5, Leute[i].x+Leute[i].shapeX, Leute[i].y+Leute[i].shapeY)&&(Leute[i].free) )
       {
         // Feindliche Einheit wird angegriffen //
         if ( Leute[i].feind )
         {
           for(j=0; j<LMAX; j++)
           {
             if ( (Leute[j].free)&&(Leute[j].aktive)&&(!Leute[j].feind) )
             {
               // Alle Aktivierten greifen die Einheit an //
               Leute[j].attack = 1;
               Leute[j].who    = i;
             }
           }
         }
         // Eigene Einheit wird ausgewhlt //
         else
         {
           for(j=0; j<LMAX; j++) Leute[j].aktive = 0;
           Leute[i].aktive = 1;
           MouseDelete = 1;
           Rahmen = 0;  return;
         }
       }
       // Mauszeiger steht auf der Landkarte
       else
       {
         // Wenn die Stelle begehbar ist //
         if ( MouseImage != 1 )
         {
           for(j=0; j<LMAX; j++)
           {
             if ( (Leute[j].free)&&(Leute[j].aktive)&&(!Leute[j].feind) )
             {
               // Zielkoordinaten angeben //
               Leute[j].attack = 0;
               Leute[j].dx = mx+ScrollX+8;
               Leute[j].dy = my+ScrollY+8;
               Leute[j].dcount = Leute[j].d1count = 0;
               WegSuchen(j);
             }
           }
         }
       }
     }

     // Zeichnet den Rahmen, falls vorhanden
     if ( Rahmen == 2 )
     {
       if ( mx < RahmenX ) { x = mx; mx1 = RahmenX; }
       else { mx1 = mx; x = RahmenX; }
       if ( my < RahmenY ) { y = my; my1 = RahmenY; }
       else { my1 = my; y = RahmenY; }

       for(i=0; i<LMAX; i++)
       {
         if ( (Leute[i].x<=mx1)&&(Leute[i].x>=x)&&(Leute[i].y<=my1)&&(Leute[i].y>=y)&&(!Leute[i].feind) )
           { Leute[i].aktive = 1; MouseSetGo(); }
       }
       Rahmen = 0; MouseDelete = 1;
     }
     if ( Rahmen == 1 ) Rahmen = 0;
   }

}


void MouseSelectMann ( void )
{
  short i, j;

  for(i=0; i<LMAX; i++)
  {
    if ( (maus_innen(Leute[i].x-10, Leute[i].y-10, Leute[i].x+Leute[i].shapeX-5, Leute[i].y+Leute[i].shapeY-5))&&(Leute[i].free)&&(!Leute[i].aktive) )
    {
      if ( cbd.mouse_code == MouseLeftUp )
      {
        for(j=0; j<LMAX; j++) if ( Leute[j].aktive ) Leute[j].aktive = 0;
        Leute[i].aktive = 1; MouseSetGo();
        MouseDelete = 1;
      } 
      if ( !Leute[i].feind ) { MouseSetMann(); break; }
    }
  }
}


void MouseSetMann ( void )
{
  m_image_start = 6;
  m_image_end   = 9;
  if ( (m_show_image < 6)||(m_show_image > 9) ) m_show_image  = 6;
  MouseImage=3;
}

void MouseSetNorm ( void )
{
  m_image_start = 1;
  m_image_end   = 1;
  m_show_image  = 1;
  MouseImage=0;
}

void MouseSetNoWay ( void )
{
  m_image_start = 10;
  m_image_end   = 10;
  m_show_image  = 10;
  MouseImage=1;
}

void MouseSetGo ( void )
{
  m_image_start = 2;
  m_image_end   = 5;
  if ( MouseImage != 2 ) m_show_image  = 2;
  if ( (m_show_image < 2)||(m_show_image > 5) ) m_show_image  = 5;
  MouseImage=2;
}

void MouseSetAttack ( void )
{
  m_image_start = 11;
  m_image_end   = 14;
//  if ( MouseImage != 11 ) m_show_image  = 11;
  if ( (m_show_image < 11)||(m_show_image > 14) ) m_show_image  = 14;
  MouseImage=4;
}
