//
// mouse.h
//
#define MouseLeftUp     xx
#define MouseLeftDown   xx
#define MouseRightUp    16
#define MouseRightDown  xx
#define MouseMove       xx        
#define m_save  0
#define m_image 1
#define m_up    3
#define m_down  4
#define m_left  2
#define m_right 5
#define m_franz 6

byte m_images[11][256], m_show_image=1;
short x1, y1;

struct callback_data
{
    int right_button;
    int mouse_event;
    unsigned short mouse_code;
    unsigned short mouse_bx;
    unsigned short MouseX;
    unsigned short MouseY;
    signed short mouse_si;
    signed short mouse_di;
} cbd = { 0 };

int lock_region (void *address, unsigned length)
{
    union REGS regs;
    unsigned linear;

    linear = (unsigned) address;

    regs.w.ax = 0x600;			/* DPMI Lock Linear Region */
    regs.w.bx = (unsigned short) (linear >> 16); /* Linear address in BX:CX */
    regs.w.cx = (unsigned short) (linear & 0xFFFF);
    regs.w.si = (unsigned short) (length >> 16); /* Length in SI:DI */
    regs.w.di = (unsigned short) (length & 0xFFFF);
    int386 (0x31, &regs, &regs);
    return (! regs.w.cflag);		/* Return 0 if can't lock */
}

#pragma off (check_stack)
void _loadds far click_handler (int max, int mbx, int mcx, int mdx, int msi, int mdi)
{
  #pragma aux click_handler parm [EAX] [EBX] [ECX] [EDX] [ESI] [EDI]
    cbd.mouse_event = 1;

    cbd.mouse_code = (unsigned short) max;
    cbd.mouse_bx   = (unsigned short) mbx;
    cbd.MouseX     = (unsigned short) mcx;
    cbd.MouseY     = (unsigned short) mdx;
    cbd.mouse_si   = (signed short) msi;
    cbd.mouse_di   = (signed short) mdi;
    if (cbd.mouse_code & 8) cbd.right_button = 1;
}

void cbc_end (void) 
{                   
}                   
#pragma on (check_stack)

void InstallMouseHandler ( void )
{
    struct SREGS sregs;
    union REGS inregs, outregs;
    int installed = 0;
    unsigned short far *ptr;
    void (far *function_ptr)();

    segread(&sregs);

    /* check for mouse driver */

    inregs.w.ax = 0;
    int386 (0x33, &inregs, &outregs);
    if( installed = (outregs.w.ax == 0xffff) ) printf("\nMaus..................OK");
    else
    {
      printf("\n\nERROR: Es wurde keine Maus gefunden!\n");
      exit(0);
    }

    if ( (! lock_region (&cbd, sizeof(cbd))) || (! lock_region ((void near *) click_handler,
         (char *) cbc_end - (char near *) click_handler)))
    {
       printf("\n\nERROR: Konnte MausHandler nicht installieren!\n" );
       exit(0);
    }
    else
    {
      inregs.w.ax = 0x1;
      int386 (0x33, &inregs, &outregs);

      /* install click watcher */
      inregs.w.ax = 0xC;
      inregs.w.cx = 1 + 2 + 4 + 8 + 16;              
      function_ptr = ( void(*)(void) ) click_handler;
      inregs.x.edx = FP_OFF (function_ptr);
      sregs.es     = FP_SEG (function_ptr);
      int386x (0x33, &inregs, &outregs, &sregs);
    }

}

void UnInstallMouseHandler ( void )
{
    union REGS inregs, outregs;

    inregs.w.ax = 0;
    int386 (0x33, &inregs, &outregs);
    if (outregs.w.ax != 0xffff) printf("\nMausHandler konnte nicht entfernt werden!\n");
}


int maus_innen ( int x, int y, int x1, int y1 )
{
  if ( (cbd.MouseX>x-1)&&(cbd.MouseX<x1+1)&&(cbd.MouseY>y-1)&&(cbd.MouseY<y1+1) ) return 1;
  else return 0;
}

void MouseBackRestore ( void )
{
  int i, j, h= 0;

  for ( i=0; i<16; i++ )
  {
    for ( j=0; j<16; j++ )
    {
      if ( ((x1+j)<ResX)&&((x1+j)>0)&&((y1+i)<ResY)&&((y1+i)>0) ) setpix(x1+j, y1+i, m_images[m_save][h]);
      h++;
    }
  }
}


void MouseBackSave ( void )
{
  int i, j, h= 0;

  for ( i=0; i<16; i++ )
  {
    for ( j=0; j<16; j++ )
    {
      m_images[m_save][h] = getpix(cbd.MouseX+j, cbd.MouseY+i);
      h++;
    }
  }
}

void MousePlace ( void )
{
  int i, j, h= 0;

  for ( i=0; i<16; i++ )
  {
    for ( j=0; j<16; j++ )
    {
      if ( m_images[m_show_image][h] != 0 )
      {
        if ( ((cbd.MouseX+j)<ResX)&&((cbd.MouseX+j)>0)&&((cbd.MouseY+i)<ResY)&&((cbd.MouseY+i)>0) ) setpix(cbd.MouseX+j, cbd.MouseY+i, m_images[m_show_image][h]);
      }
      h++;
    }
  }
}

void MouseLoadImages ( void )
{
  FILE *Datei;
  short i=0, Zeichen;
  char *ptr;

  chdir("RESOURCE");

  if ( (Datei = fopen("maus.rsc", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'maus.rsc' nicht laden!\n\n");
    exit(0);
  }
  i=256; ptr = m_images;
  while ((Zeichen = fgetc(Datei)) != EOF) ptr[i++] = (byte)Zeichen; 
  fclose(Datei);

  chdir("..");
}


int MouseReset( void )
{
  regs.x.eax = 0x0000;               
  int386( 0x33, &regs, &regs );

  if ( regs.x.eax == 0xFFFF ) return 0;
  return 1;
}

