//**************************************************************************//
// Include-Datei mit PCX-Routinen fr WATCOM C                              //
// -------------------------------------------                              //
// von Stephan Meiner                                                      //
// ab 25. Mrz 1996                                                         //
//**************************************************************************//
byte Palette[768];


/****************************************************************************/
/* Entkodiert eine PCX-Datei in den virtuellen Bildschirm, ohne die         */
/* Palette zu setzen.                                                       */    
/* ------------------------------------------------------------------------ */
/* Parameter: Name der PCX-Datei                                            */
/****************************************************************************/
void put_PCX( char Name[127] )
{
  int i, Farbe, Faktor, Zeichen, x= 0, y= 0;
  FILE *Datei;

  if ( (Datei = fopen(Name, "rb")) == NULL )
  {
    textmodus();
    printf("\n\nERROR: Kann '%s' nicht laden!\n\n", Name);
    exit(0);
  }
  for (i=0; i<128; i++) Zeichen = fgetc(Datei);        //den Header berlesen

  while ( y <= (ResY-1) )
  {
    Zeichen = fgetc(Datei);                      // wenn kein Wiederholfaktor

    if ( Zeichen > 191 )                          // wenn ein Wiederh.faktor
    {
      Faktor = ( Zeichen - 192 );
      Farbe  = fgetc(Datei);
      memset(&VScreen[(ResX*y)+x], Farbe, Faktor);
      x += Faktor;
      if ( x >= ResX ) { x = x-ResX; y++; }
    }
    if ( Zeichen <= 191 )
    {
      setpix(x, y, Zeichen); x++;
      if ( x >= ResX ) { x = 0; y++; }
    }
  }
  fclose(Datei);
}


/****************************************************************************/
/* Entkodiert eine PCX-Datei in den virtuellen Bildschirm, und setzt auch   */
/* gleich die Palette.                                                      */    
/* ------------------------------------------------------------------------ */
/* Parameter: Name der PCX-Datei                                            */
/****************************************************************************/
void show_PCX( char Name[127] )
{
  int i, Farbe, Faktor, Zeichen, x= 0, y= 0;
  FILE *Datei;

  if ( (Datei = fopen(Name, "rb")) == NULL )
  {
    textmodus();
    printf("\n\nERROR: Kann '%s' nicht laden!\n\n", Name);
    exit(0);
  }
  for (i=0; i<128; i++) Zeichen = fgetc(Datei);        //den Header berlesen

  while ( y <= (ResY-1) )
  {
    Zeichen = fgetc(Datei);                      // wenn kein Wiederholfaktor

    if ( Zeichen > 191 )                          // wenn ein Wiederh.faktor
    {
      Faktor = ( Zeichen - 192 );
      Farbe  = fgetc(Datei);
      memset(&VScreen[(ResX*y)+x], Farbe, Faktor);
      x += Faktor;
      if ( x >= ResX ) { x = x-ResX; y++; }
    }
    if ( Zeichen <= 191 )
    {
      setpix(x, y, Zeichen); x++;
      if ( x >= ResX ) { x = 0; y++; }
    }
  }
  fseek(Datei, -768L, SEEK_END);
  fread(Palette, 768, 1, Datei);

  fclose(Datei);
  SetPalette(Palette);
}

/****************************************************************************/
/* Ld die Palette aus der angegebenen Datei in einen bergebenen Puffer.   */
/* ------------------------------------------------------------------------ */
/* Parameter: Name der PCX-Datei, plus Speicherplatz fr die Palette.       */
/****************************************************************************/
void LoadPalette(char Name[127], char Palette[786] )
{
  FILE *Datei;

  Datei = fopen(Name, "rb");
  fseek(Datei, -768L, SEEK_END);
  fread(Palette, 768, 1, Datei);
  fclose(Datei);
}


void ShowPalette(char Name[127] )
{
  FILE *Datei;

  Datei = fopen(Name, "rb");
  fseek(Datei, -768L, SEEK_END);
  fread(Palette, 768, 1, Datei);
  fclose(Datei);
  SetPalette(Palette);
}

/****************************************************************************/
/* Setzt die Farbe des Bildschirmrahmens.                                   */
/* ------------------------------------------------------------------------ */
/* Parameter: Farbe des Rahmens.                                            */
/****************************************************************************/
void SetOverscanColor( byte color )
{
  outp(0x3c0,0x11);  // Index fr Overscan-Register schreiben
  outp(0x3c0,color); // Farbe setzen
  outp(0x3c0,0x20);  // Bit 5 im Indexregister lschen
}

/****************************************************************************/
/* Setzt die bergebene Palette.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: Zeiger auf die Palette.                                       */
/****************************************************************************/
void SetPalette(char *Palette)
{
/*  short int i;
  char far *p;

  for (i=0; i<768; i++) Palette[i] = Palette[i] >> 2;
  p = Palette;

  outp(0x3c6, 0xff);
  for (i=0; i<=255; i++)
  {
    outp(0x3c8, i);
    outp(0x3c9, *p++);
    outp(0x3c9, *p++);
    outp(0x3c9, *p++);
  }

return;*/

  short i;

  for (i=0; i<768; i++) Palette[i] = Palette[i] >> 2;
  outp(0x03c8,0);
  
  for (i=0;i<768;i++) outp(0x03c9,Palette[i]);

}

/****************************************************************************/
/* Ermittelt die gerade gesetzte Palette.                                   */
/* ------------------------------------------------------------------------ */
/* Parameter: Zeiger auf die Palette.                                       */
/****************************************************************************/
void GetPalette ( byte *Palette )
{
   short i;

   outp(0x03c7, 0);
   for (i=0; i<768; i++) Palette[i] = inp(0x03c9);
}


void wait_retrace(void)
{
  while ((inp(0x03da) & 1) != 0);
  while ((inp(0x03da) & 1) == 0); 
}


