//**************************************************************************//
// Include-Datei mit PCX-Routinen fr WATCOM C                              //
// -------------------------------------------                              //
// von Stephan Meiner                                                      //
// ab 25. Mrz 1996                                                         //
//**************************************************************************//
typedef struct
{
        byte rot, gruen, blau;
} PAL;


PAL Palette[256];


/****************************************************************************/
/* Entkodiert eine PCX-Datei in den virtuellen Bildschirm, ohne die         */
/* Palette zu setzen.                                                       */    
/* ------------------------------------------------------------------------ */
/* Parameter: Name der PCX-Datei                                            */
/****************************************************************************/
void put_PCX( char Name[127] )
{
  int i, Farbe, Faktor, Zeichen, x= 0, y= 0;
  FILE *Datei;

  if ( (Datei = fopen(Name, "rb")) == NULL )
  {
    textmodus();
    printf("\n\nERROR: Kann '%s' nicht laden!\n\n", Name);
    exit(0);
  }
  for (i=0; i<128; i++) Zeichen = fgetc(Datei);        //den Header berlesen

  while ( y <= (ResY-1) )
  {
    Zeichen = fgetc(Datei);                      // wenn kein Wiederholfaktor

    if ( Zeichen > 191 )                          // wenn ein Wiederh.faktor
    {
      Faktor = ( Zeichen - 192 );
      Farbe  = fgetc(Datei);
      memset(&VScreen[(ResX*y)+x], Farbe, Faktor);
      x += Faktor;
      if ( x >= ResX ) { x = x-ResX; y++; }
    }
    if ( Zeichen <= 191 )
    {
      setpix(x, y, Zeichen); x++;
      if ( x >= ResX ) { x = 0; y++; }
    }
  }
  fclose(Datei);
}


/****************************************************************************/
/* Entkodiert eine PCX-Datei in den virtuellen Bildschirm, und setzt auch   */
/* gleich die Palette.                                                      */    
/* ------------------------------------------------------------------------ */
/* Parameter: Name der PCX-Datei                                            */
/****************************************************************************/
void show_PCX( char Name[127] )
{
  int i, Farbe, Faktor, Zeichen, x= 0, y= 0;
  FILE *Datei;

  if ( (Datei = fopen(Name, "rb")) == NULL )
  {
    textmodus();
    printf("\n\nERROR: Kann '%s' nicht laden!\n\n", Name);
    exit(0);
  }
  for (i=0; i<128; i++) Zeichen = fgetc(Datei);        //den Header berlesen

  while ( y <= (ResY-1) )
  {
    Zeichen = fgetc(Datei);                      // wenn kein Wiederholfaktor

    if ( Zeichen > 191 )                          // wenn ein Wiederh.faktor
    {
      Faktor = ( Zeichen - 192 );
      Farbe  = fgetc(Datei);
      memset(&VScreen[(ResX*y)+x], Farbe, Faktor);
      x += Faktor;
      if ( x >= ResX ) { x = x-ResX; y++; }
    }
    if ( Zeichen <= 191 )
    {
      setpix(x, y, Zeichen); x++;
      if ( x >= ResX ) { x = 0; y++; }
    }
  }
  fseek(Datei, -768L, SEEK_END);
  fread(Palette, 768, 1, Datei);

  fclose(Datei);
  SetPalette(Palette);
}

void ShowRif ( char *Name )
{
  FILE *Datei;

  if ( (Datei = fopen(Name, "rb")) == NULL )
  {
    textmodus();
    printf("\n\nERROR: Kann '%s' nicht laden!\n\n", Name);
    exit(0);
  }

  fread(&VScreen, 640, 400, Datei);

  fseek(Datei, -768L, SEEK_END);
  fread(Palette, 768, 1, Datei);

  fclose(Datei);
  SetPalette(Palette);
}


/****************************************************************************/
/* Ld die Palette aus der angegebenen Datei in einen bergebenen Puffer.   */
/* ------------------------------------------------------------------------ */
/* Parameter: Name der PCX-Datei, plus Speicherplatz fr die Palette.       */
/****************************************************************************/
void LoadPalette(char Name[127], PAL *Palette )
{
  FILE *Datei;

  Datei = fopen(Name, "rb");
  fseek(Datei, -768L, SEEK_END);
  fread(Palette, 768, 1, Datei);
  fclose(Datei);
}


void ShowPalette(char *Name )
{
  FILE *Datei;

  Datei = fopen(Name, "rb");
  fread(Palette, 768, 1, Datei);
  fclose(Datei);
  SetPalette(Palette);
}

/****************************************************************************/
/* Setzt die Farbe des Bildschirmrahmens.                                   */
/* ------------------------------------------------------------------------ */
/* Parameter: Farbe des Rahmens.                                            */
/****************************************************************************/
void SetOverscanColor( byte color )
{
  outp(0x3c0,0x11);  // Index fr Overscan-Register schreiben
  outp(0x3c0,color); // Farbe setzen
  outp(0x3c0,0x20);  // Bit 5 im Indexregister lschen
}

/****************************************************************************/
/* Setzt die bergebene Palette.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: Zeiger auf die Palette.                                       */
/****************************************************************************/
void SetPalette ( PAL *Palette )
{
  short int i;
  char far *p;

  p = Palette;

  outp(0x3c6, 0xff);
  for (i=0; i<=255; i++)
  {
    outp(0x3c8, i);
    outp(0x3c9, *p++ >> 2);
    outp(0x3c9, *p++ >> 2);
    outp(0x3c9, *p++ >> 2);
  }

return;

}

/****************************************************************************/
/* Ermittelt die gerade gesetzte Palette.                                   */
/* ------------------------------------------------------------------------ */
/* Parameter: Zeiger auf die Palette.                                       */
/****************************************************************************/
void GetPalette ( PAL *Palette )
{
   short i;

   outp(0x03c7, 0);
   for (i=0; i<256; i++)
   {
     Palette[i].rot   = inp(0x03c9) << 2;
     Palette[i].gruen = inp(0x03c9) << 2;
     Palette[i].blau  = inp(0x03c9) << 2;
   }
}


void wait_retrace(void)
{
  while ((inp(0x03da) & 1) != 0);
  while ((inp(0x03da) & 1) == 0); 
}

void FadeOut ( void )
{
  short i;
  byte fertig=0;

  GetPalette(&Palette);

  while ( fertig == 0 )
  {
    fertig = 1;

    for(i=0; i<256; i++)
    {
      if ( Palette[i].rot   != 0 ) { Palette[i].rot--;   fertig = 0; }
      if ( Palette[i].gruen != 0 ) { Palette[i].gruen--; fertig = 0; }
      if ( Palette[i].blau  != 0 ) { Palette[i].blau--;  fertig = 0; }
    }
    SetPalette(&Palette); delay(1);
  }

}

void FadeIn ( void )
{
  short i;
  byte fertig=0;
  PAL pal[256] = { 0 };

  GetPalette(&Palette);

  while ( fertig == 0 )
  {
    fertig = 1;

    for(i=0; i<256; i++)
    {
      if ( pal[i].rot   < Palette[i].rot )   { pal[i].rot++;   fertig=0; }
      if ( pal[i].gruen < Palette[i].gruen ) { pal[i].gruen++; fertig=0; }
      if ( pal[i].blau  < Palette[i].blau )  { pal[i].blau++;  fertig=0; }
    }
    SetPalette(&pal);
  }
}

void FlashOut ( void )
{
  short i;
  byte fertig=0;

  GetPalette(&Palette);

  while ( fertig == 0 )
  {
    fertig = 1;

    for(i=1; i<256; i++)
    {
      if ( Palette[i].rot   != 255 ) { Palette[i].rot++;   fertig = 0; }
      if ( Palette[i].gruen != 255 ) { Palette[i].gruen++; fertig = 0; }
      if ( Palette[i].blau  != 255 ) { Palette[i].blau++;  fertig = 0; }
    }
    SetPalette(&Palette);
  }

}

void FlashIn ( void )
{
  short i;
  byte fertig=0;
  PAL pal[256];

  memset(pal, 255, 768);
  GetPalette(&Palette);

  while ( fertig == 0 )
  {
    fertig = 1;

    for(i=0; i<256; i++)
    {
      if ( pal[i].rot   > Palette[i].rot )   { pal[i].rot--;   fertig=0; }
      if ( pal[i].gruen > Palette[i].gruen ) { pal[i].gruen--; fertig=0; }
      if ( pal[i].blau  > Palette[i].blau )  { pal[i].blau--;  fertig=0; }
    }
    SetPalette(&pal);
  }
}

void GrayIn ( void )
{
  short i;
  byte fertig=0;
  PAL pal[256];

  GetPalette(&Palette);
  GetPalette(&pal);

  while ( fertig == 0 )
  {
    fertig = 1;

    for(i=0; i<256; i++)
    {
      if ( pal[i].rot   > (Palette[i].rot*80)/100 )   { pal[i].rot--;   fertig=0; }
      if ( pal[i].gruen > (Palette[i].gruen*80)/100 ) { pal[i].gruen--; fertig=0; }
      if ( pal[i].blau  > (Palette[i].blau*80)/100 )  { pal[i].blau--;  fertig=0; }
    }
    SetPalette(&pal);
  }
}

void BildAus ( void )
{
  short i;

  FlashOut();
  for(i=0; i<198; i+=4)
  {
    memset(&VScreen[(ResX*i)], 0, ResX*4); memset(&VScreen[(ResX*(398-i))], 0, ResX*4);
    Cpy2Screen();
  }
  for(i=0; i<318; i+=4)
  {
    memset(&VScreen[(ResX*198)+i], 0, 4); memset(&VScreen[(ResX*199)+i], 0, 4);
    memset(&VScreen[(ResX*200)+i], 0, 4); memset(&VScreen[(ResX*201)+i], 0, 4);
    memset(&VScreen[(ResX*198)+(640-i)], 0, 4); memset(&VScreen[(ResX*199)+(640-i)], 0, 4);
    memset(&VScreen[(ResX*200)+(640-i)], 0, 4); memset(&VScreen[(ResX*201)+(640-i)], 0, 4);
    Cpy2Screen();
  }
  FadeOut();
}

