#include <stdio.h>
#include <conio.h>

typedef unsigned WORD;
typedef unsigned char BYTE;

void put_PCX( char Name[127] );
void load_PCX( char Name[127] );
void fade_in_PCX( char Name[127], int del1, int del2 );
void PCX2sprt( char PCX_Name[127], char SPRT_Name[127] );
void LoadPalette(char Name[127], char Palette[768] );
void ClearPalette ( void );
void SetPalette(char *Palette);
void GetPalette ( BYTE *Palette );
void set_fade_in( WORD start, WORD end, BYTE *Palette, BYTE blend );
void fade_in( BYTE del, BYTE del2, BYTE *Palette );
void fade_out( BYTE del, BYTE del2 );
extern void WaitRetrace ( void );
/*-------------------------------------------------------------------------*/
void put_PCX( char Name[127] )
{
  int i, Farbe, Faktor, Zeichen, x= -1, y= 0;
  char Palette[768];
  FILE *Datei;

  if ( (Datei = fopen(Name, "rb")) == NULL ) return;

  fseek(Datei, 0, SEEK_SET);

  for (i=0; i<128; i++) Zeichen = fgetc(Datei);       /*den Header berlesen*/

  while ( y <= 199 )
  {
    Zeichen = fgetc(Datei);                      /*wenn kein Wiederholfaktor*/
    if ( Zeichen >  191 )                          /*wenn ein Wiederh.faktor*/
    {
      Faktor = ( Zeichen - 192 );
      Farbe  = fgetc(Datei);
      for (i=0; i<Faktor; i++)
      {
	 setpix(x, y, Farbe); x++;
	 if ( x >= 319 ) { x = -1; y++; }
      }
    }
    else
    {
      setpix(x, y, Zeichen); x++;
      if ( x >= 319 ) { x = -1; y++; }
    }
  }
  fclose(Datei);
}


void load_PCX( char Name[127] )
{
  char pal[768];

  ClearPalette();
  put_PCX(Name);
  LoadPalette(Name, pal);
  SetPalette(pal);
}


void fade_in_PCX( char Name[127], int del1, int del2 )
{
  char pal[768];

  ClearPalette();
  put_PCX(Name);
  LoadPalette(Name, pal);
  fade_in(del1, del2, pal);
}


void PCX2sprt( char PCX_Name[127], char SPRT_Name[127] )
{
  FILE *PCX, *SPRT;
  int i, Farbe, Faktor, x= -1, y= 0;
  int Zeichen;

  PCX = fopen(PCX_Name, "rb"); SPRT = fopen(SPRT_Name, "wb");

  for (i=0; i<128; i++) Zeichen = fgetc(PCX);

  while ( y <= 20 )
  {
    Zeichen = fgetc(PCX);
    if ( Zeichen >  191 )
    {
      Faktor = ( Zeichen - 192 );
      Farbe  = fgetc(PCX);
      for (i=0; i<Faktor; i++)
      {
	if ( x < 19 ) fputc(Farbe, SPRT);
	x++;
	if ( x >= 319 ) { x= -1; y++; }
      }
    }
    if ( Zeichen < 191 )
    {
      if ( x < 19 ) fputc(Zeichen, SPRT);
      x++;
      if ( x >= 319 ) { x= -1; y++; }
    }
  }

  fclose(PCX); fclose(SPRT);
}


void LoadPalette(char Name[127], char Palette[786] )
{
  FILE *Datei;

  Datei = fopen(Name, "rb");
  fseek(Datei, -768L, SEEK_END);
  fread(Palette, 768, 1, Datei);
  fclose(Datei);
}

void SetPalette(char *Palette)
{
  short int i;
  char far *p;

  for (i=0; i<768; i++) Palette[i] = Palette[i] >> 2;
  p = Palette;

  outportb(0x3c6, 0xff);
  for (i=0; i<=255; i++)
  {
    outportb(0x3c8, i);
    outportb(0x3c9, *p++);
    outportb(0x3c9, *p++);
    outportb(0x3c9, *p++);
  }

return;
}


void GetPalette ( BYTE *Palette )
{
   WORD i;

   outportb(0x03c7, 0);
   for (i=0; i<768; i++) Palette[i] = inportb(0x03c9);
}

void ClearPalette ( void )
{
  BYTE palette[786] = {0};
  SetPalette(palette);
}



void set_fade_in( WORD start, WORD end, BYTE *Palette, BYTE blend )
{
  WORD i;

  start *=3; end++; end *=3;

  outportb(0x3c6, 255);

  for (i=start; i<=end; i++) outportb(0x3c9, Palette[i]*blend >> 7);
  return;
}




void fade_in( BYTE del, BYTE del2, BYTE *Palette )
{
   int count;

   for (count=0; count<128; count+=del2)
   {
     set_fade_in(0, 255, Palette, count);
     delay(del);
     WaitRetrace();
   }
   return;
}


void fade_out( BYTE del, BYTE del2 )
{
   int count;
   BYTE *Palette;

   GetPalette(Palette);

   for (count=128; count>0; count-=del2)
   {
     WaitRetrace();
     delay(del);
     set_fade_in(0, 255, Palette, count);
   }
   return;
}
