#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>

int XMSInit( void );
void XMSQueryFree( int * GesFrei, int * MaxBl );
int XMSGetMem( int LenKb );
void XMSFreeMem( int Handle );
void XMSCopy( int VonHandle, long VonOffset, int NachHandle, long NachOffset, long LenW );
long XMSLock( int Handle );
void XMSUnlock( int Handle );


typedef unsigned char BYTE;
typedef unsigned WORD;
typedef struct                        /* Informationen fr XMS-Aufruf */
{
	  WORD AX,              /* nur die Register AX, BX, DX und SI */
	       BX,              /* werden je nach aufgerufener Funk-  */
	       DX,              /* tion bentigt, dazu noch eine Seg- */
	       SI,              /* mentadresse                        */
	       Segment;
} XMSRegs;

typedef struct                        /* eine extended-Memory-Move-Struktur */
{
	  long LenB;                             /* Anzahl zu versch. Bytes */
	  int  SHandle;                                    /* Source-Handle */
	  long SOffset;                                    /* Source-Offset */
	  int  DHandle;                               /* Destination-Handle */
	  long DOffset;                               /* Destination-Offset */
} EMMS;

void far *XMSPtr;           /* Zeiger auf den Extended-Memory-Manager (XMM) */

/*-------------------------- XMS-Routinen ----------------------------------*/
/****************************************************************************/
/*--------------------------------------------------------------------------*/
int XMSInit( void )
{
 union REGS Regs;                  /* Prozessorregister fr Interruptaufruf */
 struct SREGS SRegs;                                     /* Segmentregister */
 XMSRegs Xr;                                     /* Register fr XMS-Aufruf */

 Regs.x.ax = 0x4300;          /* Verfgbarkeit des XMS-Managers feststellen */
 int86( 0x2F, &Regs, &Regs );                    /* DOS-Dispatcher aufrufen */

 if ( Regs.h.al == 0x80 )                       /* XMS-Manager angetroffen? */
  {                                                                   /* Ja */
   Regs.x.ax = 0x4310;                 /* Einsprungspunkt des XMM ermitteln */
   int86x( 0x2F, &Regs, &Regs, &SRegs );
   XMSPtr = MK_FP( SRegs.es, Regs.x.bx );        /*Adresse in glob. Var. sp.*/
   return 1;                    /* Handler angetroffen, Modul initialisiert */
  }
 else                                       /* kein XMS-Handler installiert */
  return 0;
}


void XMSQueryFree( int * GesFrei, int * MaxBl )
{
 XMSRegs Xr;                                     /* Register fr XMS-Aufruf */

 XMSCall( 8, &Xr );                             /* XMS-Funktion #8 aufrufen */
 *GesFrei = Xr.AX;                               /* Gesamtgre steht in AX */
 *MaxBl   = Xr.DX;                           /* freier Speicher steht in DX */
}


int XMSGetMem( int LenKb )
{
 XMSRegs Xr;                                     /* Register fr XMS-Aufruf */

 Xr.DX = LenKb;                      /* Lnge wird im DX-Register bergeben */
 XMSCall( 9, &Xr );                             /* XMS-Funktion #9 aufrufen */
 return Xr.DX;                                      /* Handle zurckliefern */
}

void XMSFreeMem( int Handle )
{
  XMSRegs Xr;                                    /* Register fr XMS-Aufruf */

  Xr.DX = Handle;                   /* Handle wird im DX-Register bergeben */
  XMSCall( 10, &Xr );                          /* XMS-Funktion #10 aufrufen */
}

void XMSCopy( int VonHandle, long VonOffset, int NachHandle, long NachOffset, long LenW )

{
  XMSRegs Xr;                                    /* Register fr XMS-Aufruf */
  EMMS Mi;                                                /* nimmt EEMS auf */
  void far * MiPtr;

  Mi.LenB =    LenW;                       /* zunchst den EMMS aufbereiten */
  Mi.SHandle = VonHandle;
  Mi.SOffset = VonOffset;
  Mi.DHandle = NachHandle;
  Mi.DOffset = NachOffset;

  MiPtr = &Mi;                               /* Far-Zeiger auf die Struktur */
  Xr.SI = FP_OFF( MiPtr );                        /* Offsetadresse des EMMS */
  Xr.Segment = FP_SEG( MiPtr );                  /* Segmentadresse des EMMS */
  XMSCall( 11, &Xr );                          /* XMS-Funktion #11 aufrufen */
}


long XMSLock( int Handle )
{
 XMSRegs Xr;                                     /* Register fr XMS-Aufruf */

 Xr.DX = Handle;                                          /* Handle des EMB */
 XMSCall( 12, &Xr );                           /* XMS-Funktion #12 aufrufen */
 return ((long) Xr.DX << 16) + Xr.BX;              /* 32-Bit-Adr. berechnen */
}

void XMSUnlock( int Handle )
{
  XMSRegs Xr;                                    /* Register fr XMS-Aufruf */

  Xr.DX = Handle;                                         /* Handle des EMB */
  XMSCall( 13, &Xr );                          /* XMS-Funktion #13 aufrufen */
}



