//**************************************************************************//
// Das hier wird die DEFKON17 Konvertierung auf WATCOM C                    //
// -----------------------------------------------------                    //
// von Stephan Meiner                                                      //
// ab 25. Mrz 1996                                                         //
//**************************************************************************//

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <i86.h>

#define MB 000000

typedef unsigned char BYTE;
typedef unsigned WORD;


BYTE Landschaft[2000000], Leute[2000000];


void main ( void )
{
  init_Spiel();
  quit();
}


/****************************************************************************/
/* Fhrt einen Maus-Reset durch.                                            */
/* ------------------------------------------------------------------------ */
/* Rckgabe, ob Maustreiber installiert ist.                                */
/****************************************************************************/
int maus_reset( void )
{
  union REGS regs;

  regs.x.ax = 0x0000;               
  int386( 0x33, &regs, &regs );

  if ( regs.x.ax == 0xFFFF ) return 0;
  return 1;
}

/****************************************************************************/
/* Setzt den Mauszeiger auf eine best. Position auf dem Bildschirm.         */
/* ------------------------------------------------------------------------ */
/* Parameter sin die x- und die y-Koordinate.                               */
/****************************************************************************/
void maus_put ( int x, int y )
{
  union REGS regs;
  x = x * 2;

  regs.x.ax = 0x0004;               
  regs.x.cx = x;
  regs.x.dx = y;
  int386( 0x33, &regs, &regs );
}

/****************************************************************************/
/* Schaltet den Hardware-Mauszeiger aus.                                    */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void maus_off ( void )
{
 union REGS regs;

 regs.x.ax = 0x0002;    
 int386( 0x33, &regs, &regs );
}

/****************************************************************************/
/* Initialisiert den Mode 13h.                                              */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void init320x200( void )
{
   union REGS regs;

   regs.x.ax = 0x0013;    
   int386( 0x10, &regs, &regs );
}

/****************************************************************************/
/* Initialisiert den Textmodus.                                             */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void textmodus( void )
{
   union REGS regs;

   regs.x.ax = 0x0003;               /* wieder in Textmodus zurckschalten */
   int386( 0x10, &regs, &regs );
}


/****************************************************************************/
/* Initialisiert das Spiel.                                                 */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void init_Spiel( void )
{
  int i, Zeichen;
  FILE *Datei;

  printf("********************** DEFKON17 - Kampf der Giganten **************************\n");
  if ( maus_reset() )        // berprfen ob ein Maustreiber installiert ist
  {
   printf("\nERROR: Es wurde kein Maustreiber gefunden!\n\n");
   exit(0);
  }
  delay(200);
  if ( chdir("DATA") )                       // ins DATA-Verzeichnis wechseln
  {
    printf("\nERROR: Kann Verzeichnis DATA nicht finden!\n\n");
    exit(0);
  }                                          
  Datei = fopen("landscp1.dat", "rb");                   // Landschaft laden
  i= 0;
  while ((Zeichen = fgetc(Datei)) != EOF) Landschaft[i++] = (BYTE)Zeichen;
  fclose(Datei);

  Datei = fopen("mann.dat", "rb");                             // Leute laden
  i= 0;
  while ((Zeichen = fgetc(Datei)) != EOF) Leute[i++] = (BYTE)Zeichen;
  fclose(Datei);

  init320x200();
  delay(200);
  maus_off(); maus_put(160, 100);                              // Maus setzen
}

/****************************************************************************/
/* Beendet das Spiel.                                                       */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void quit ( void )
{
  chdir("..");
  textmodus();
  printf("\nDu hast diese Zeit verloren!\n");
  exit(0);
}


