//**************************************************************************//
// Das hier wird die DEFKON17 Konvertierung auf WATCOM C                    //
// -----------------------------------------------------                    //
// von Stephan Meiner                                                      //
// ab 25. Mrz 1996                                                         //
//**************************************************************************//
#include <stdio.h>
#include <conio.h>
#include <graph.h>
#include <dos.h>
#include <i86.h>
#include <gfklib.h>
#include <pcxlib.h>
#include <maus.h>

#define ML   MannListe
#define STRG 36
#define M0   0
#define M1   4
#define M2  10
#define M3  17
#define M4  24

typedef struct
{
          BYTE shape, back, energie, del, type;
	  int x, y, x1, y1;
	  int ax, ay;
	  int dx, dy, dx1, dy1;
} MANN;


BYTE LandData[500000], MannData[500000], MannBack[500000], Feld[1000][1000], BFeld[1000][1000];
MANN MannListe[200];
BYTE AktListe[200], MoveListe[200];
int f_x=0; f_y=0, MannAnzahl= -1, scroll_del, mann_del, ss_del, sm_del;
int SPIEL_BREIT  = 12;
int SPIEL_LANG   = 9;
int FELD_X;
int FELD_Y;


void main ( void )
{
  int i, j;
  union REGS regs; char c;

  init_Spiel(); ss_del = scroll_del; sm_del = mann_del;

  Screen_Off();
  load_PCX("mr-003.pcx"); Set_Overscan_Color(0); 

  Landschaft(0, 0);
  cpy2screen(); Screen_On(); 

  while ( m_taste != 7 )                                  // sinnlose Abfrage
  {
    m_show_image= 1; maus_pos(); maus_show();

    if ( m_taste == 1 ) maus_links();
    if ( m_taste == 2 ) maus_rechts();

    if ( kbhit() )
    {
      c = getch();
      if ( c == 27 ) quit();
      if ( c == 45 ) { mann_del+=4; }                                // -
      if ( c == 43 ) { if ( mann_del > 4 ) mann_del-=4; }            // +
      if ( c == 47 ) { scroll_del+=4; }                              // /
      if ( c == 42 ) { if ( scroll_del > 4 ) scroll_del-=4; }        // *
      if ( c ==  8 ) { scroll_del = ss_del; mann_del = sm_del; }     // bs
      if ( c == 32 ) { memset(BFeld, 1, 1000*1000); Landschaft(f_x, f_y); }
      if ( c == 13 )
      {
        m_back_restore();
        MannInsert((f_x*20)+m_x, (f_y*20)+m_y, 0, 0); mann_set(MannAnzahl); m_back_save(); m_place();
      }
    }
    memset(MoveListe, 0, MannAnzahl+1); 
    //-------------------------------------------------------------------
    if ( (m_y>180)&&(f_y<FELD_Y) ) { scroll_down();  delay(scroll_del); }
    if ( (m_y< 10)&&(f_y>0) )      { scroll_up();    delay(scroll_del); }
    if ( (m_x>310)&&(f_x<FELD_X) ) { scroll_right(); delay(scroll_del); }
    if ( (m_x< 10)&&(f_x>0) )      { scroll_left();  delay(scroll_del); }
    //-------------------------------------------------------------------

    if ( MannAnzahl > -1 )
    {
      m_back_restore();
      for ( i=0; i<MannAnzahl+1; i++ )
      {
        Mann_compute(i);
        if ( MoveListe[i] == 1 )
        {
          Mann_back_restore(i);
          if ( AktListe[i] ) mann_akt_set(i);
          else mann_set(i);
          ML[i].x1 = ML[i].x; ML[i].y1 = ML[i].y;
        }
      }
      m_back_save(); m_place();
    }

    if ( screen_refresh ) { wait_retrace(); cpy2screen(); }
  }
  quit();
}

/****************************************************************************/
/* put_sprite bring ein Sprite von 20x20 auf den Bildschirm. Zuvor mu ihr  */
/* aber die Position des Sprites im XMS bergeben werden, sowie die X- und  */
/* Y-Koordinaten.                                                           */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            x................................... X-Koordinate des Sprites */
/*            y................................... Y-Koordinate des Sprites */
/*            pos................................... Sprite-Position im XMS */
/****************************************************************************/
void put_sprite( int x, int y, unsigned int pos )
{
  int i= y, j= x, h= pos;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ ) vsetpix(x+j, y+i, LandData[h++]);
  }
}

void put_black_sprite( int x, int y )
{
  int i= y, j= x;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ ) vsetpix(x+j, y+i, 255);
  }
}

/****************************************************************************/
/* Dies Funktion stellt das Grundgrst fr diese Spiel dar. Sie berechnet   */
/* welche Teile der Landschaft (Karte) angezeigt werden soll. 	            */
/* Gesteuert wird per Maus.						    */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            weiter_x..................... wie weit in X-Richtung scrollen */
/*            weiter_y..................... wie weit in Y_Richtung scrollen */
/****************************************************************************/
void Landschaft ( int weiter_x, int weiter_y )
{
  int i, j;

  for (i=weiter_y; i<weiter_y+SPIEL_LANG; i++)          
  {
    for (j=weiter_x; j<weiter_x+SPIEL_BREIT; j++)     
    {
      if ( BFeld[i][j] == 1 ) put_sprite((j-weiter_x)*20+74, (i-weiter_y)*20+11, Feld[i] [j]*400);
      if ( BFeld[i][j] == 0 ) put_black_sprite((j-weiter_x)*20+74, (i-weiter_y)*20+11);
    }
  }
}



/****************************************************************************/
/* Initialisiert das Spiel.                                                 */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void init_Spiel( void )
{
  int i, Zeichen;
  FILE *Datei;
  char DateiName[127];

  Screen_On(); 
  if ( maus_reset() )        // berprfen ob ein Maustreiber installiert ist
  {
   printf("\nERROR: Es wurde kein Maustreiber gefunden!\n\n");
   exit(0);
  }
  load_ini();

  delay(400);
  if ( chdir("DATA") )                       // ins DATA-Verzeichnis wechseln
  {
    printf("\nERROR: Kann Verzeichnis DATA nicht finden!\n\n");
    exit(0);
  }                                          
  Datei = fopen("landscp1.dat", "rb");                   // Landschaft laden
  i= 0;
  while ((Zeichen = fgetc(Datei)) != EOF) LandData[i++] = (BYTE)Zeichen;
  fclose(Datei);
  Datei = fopen("mann.dat", "rb");                             // Leute laden
  i= 0;
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);

  memset(BFeld, 0, 1000*1000);
  printf("\nName der Karte die geladen werden soll: ");
  printf("\n---------------------------------------\n");
  printf("Dateiname: "); scanf("%s", DateiName);
  load_map(DateiName); fade_out();
  init320x200();
  delay(200);
  maus_off(); maus_put(160, 100);                              // Maus setzen
}


void scroll_down ( void )
{
  int i;

  f_y++;
  m_back_restore();
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].y1=ML[i].y-=20; 
      if ( AktListe[i] ) mann_akt_set(i);
      else mann_set(i);
    }
  }
  m_show_image=m_down; m_back_save(); m_place();
}

void scroll_up ( void )
{
  int i;

  f_y--;
  m_back_restore();
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].y1=ML[i].y+=20; 
      if ( AktListe[i] ) mann_akt_set(i);
      else mann_set(i);
    }
  }
  m_show_image=m_up; m_back_save(); m_place();
}

void scroll_right ( void )
{
  int i;

  f_x++;
  m_back_restore();
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].x1=ML[i].x-=20;
      if ( AktListe[i] ) mann_akt_set(i);
      else mann_set(i);
    }
  }
  m_show_image=m_right; m_back_save(); m_place();
}

void scroll_left ( void )
{
  int i;

  f_x--;
  m_back_restore();
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].x1=ML[i].x+=20; 
      if ( AktListe[i] ) mann_akt_set(i);
      else mann_set(i);
    }
  }
  m_show_image=m_left; m_back_save(); m_place();
}

void maus_links ( void )
{
  int i, j, keyb_flag=0;
  union REGS regs;

  regs.h.ah = 0x02; int386( 0x16, &regs, &regs );
  regs.h.ah = 0x00; keyb_flag = regs.x.ax;

  if ( (m_x>73)&&(m_x<314)&&(m_y>10)&&(m_y<191) )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( (m_x>ML[i].x)&&(m_x<ML[i].x+20)&&(m_y>ML[i].y)&&(m_y<ML[i].y+20) )
      {
        if ( keyb_flag != STRG )
        {
          if ( ML[i].type )                // Wenn ein Gegner angewhlt wurde
          {
            for ( j=0; j<MannAnzahl+1; j++ )    // Ist ein eigener Mann aktiv
            {
              if ( (AktListe[j]) ) { ML[j].dx = (f_x*20)+m_x-10; ML[j].dy = (f_y*20)+m_y-10; }
              return;
            }
          }
          else { for ( j=0; j<MannAnzahl+1; j++ ) if ( AktListe[j] ) { mann_back_restore(j); mann_set(j); AktListe[j]=0; } }
        }
        AktListe[i] = 1;
        m_back_restore(); mann_back_restore(i); mann_akt_set(i); m_back_save(); m_place();
        m_taste= 0; return;
      }
    }
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( (AktListe[i])&&(!ML[i].type) ) { ML[i].dx = (f_x*20)+m_x-10; ML[i].dy = (f_y*20)+m_y-10; }
    }
  }
}

void maus_rechts ( void )
{
  int i;

  for ( i=0; i<MannAnzahl+1; i++ )
  {
    if ( AktListe[i] ) { mann_back_restore(i); mann_set(i); }
    AktListe[i] = 0;
  }
}

void load_map ( char MapName[127] )
{
  FILE *Datei;
  int i, j, x_lang, y_breit;

  chdir(".."); chdir("map");

  Datei = fopen(MapName, "rb");
  FELD_X = fgetc(Datei); FELD_Y = fgetc(Datei); x_lang = fgetc(Datei); y_breit = fgetc(Datei)+1;
  for (i=0; i<y_breit+1; i++ )
  {
    for (j=0; j<x_lang+1; j++ ) Feld[i][j] = fgetc(Datei);
  }
  fclose(Datei);

  chdir(".."); chdir("data");
}

void load_ini ( void )
{
  FILE *Datei;
  char ini[3];
  int i;

  Datei = fopen("defkon.ini", "rb"); i= 0;
  memset(ini, 32, 3); while ( fgetc(Datei) != '=' ); while ( (ini[i++] = fgetc(Datei)) != '.');
    scroll_del = atoi(ini);
  memset(ini, 32, 3); while ( fgetc(Datei) != '=' ); while ( (ini[i++] = fgetc(Datei)) != '.');
    mann_del = atoi(ini);
  fclose(Datei);
}


/****************************************************************************/
/* Beendet das Spiel.                                                       */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void quit ( void )
{
  fade_out();
  chdir("..");
  textmodus();
  printf("Du hast diese Zeit verloren!\n");
  exit(0);
}



/****************************************************************************/
/* "Erschafft" einen neuen Mann.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int MannInsert ( int ax, int ay, BYTE shape, BYTE type )
{

  MannAnzahl++;
  MannListe[MannAnzahl].del     = 0;
  MannListe[MannAnzahl].x       = ax-(f_x*20);
  MannListe[MannAnzahl].y       = ay-(f_y*20);
  MannListe[MannAnzahl].x1      = ax-(f_x*20);
  MannListe[MannAnzahl].y1      = ay-(f_y*20);
  MannListe[MannAnzahl].ax      = ax;
  MannListe[MannAnzahl].ay      = ay;
  MannListe[MannAnzahl].dx      = ax;
  MannListe[MannAnzahl].dy      = ay;
  MannListe[MannAnzahl].shape   = shape;
  MannListe[MannAnzahl].energie = 10;
  MannListe[MannAnzahl].type    = type;
  MannListe[MannAnzahl].back    = MannAnzahl*400;
  AktListe[MannAnzahl]          = 0;

  return 1;
}

void Mann_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].x1+j)<315)&&((ML[index].x1+j)>73)&&((ML[index].y1+i)>10)&&((ML[index].y1+i)<191) )
        vsetpix(ML[index].x1+j, ML[index].y1+i, MannBack[h]);
      h++;
    }
  }

}

void Mann_set ( BYTE index )
{
  int i, j, h=index*400, k=ML[index].shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].x+j)<315)&&((ML[index].x+j)>73)&&((ML[index].y+i)>10)&&((ML[index].y+i)<191) )
      {
        MannBack[h] = vgetpix( ML[index].x+j, ML[index].y+i);
        if ( ((MannData[k]>5)&&(MannBack[h]<38)) ) vsetpix( ML[index].x+j, ML[index].y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
}

void Mann_akt_set ( BYTE index )
{
  int i, j, h=index*400, k=ML[index].shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].x+j)<315)&&((ML[index].x+j)>73)&&((ML[index].y+i)>10)&&((ML[index].y+i)<191) )
      {
        MannBack[h] = vgetpix( ML[index].x+j, ML[index].y+i);
        if ( ((MannData[k]>5)&&(MannBack[h]<38)) ) vsetpix( ML[index].x+j, ML[index].y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
  //---------------------------- Y-Werte ------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+i)<314)&&((ML[index].x+i)>73)&&((ML[index].y+ 1)>10)&&((ML[index].y+ 1)<191) ) vsetpix(ML[index].x+i, ML[index].y+1,  254);
  for ( i=14; i<18; i++ ) if ( ((ML[index].x+i)<314)&&((ML[index].x+i)>73)&&((ML[index].y+ 1)>10)&&((ML[index].y+ 1)<191) ) vsetpix(ML[index].x+i, ML[index].y+1,  254);
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+i)<314)&&((ML[index].x+i)>73)&&((ML[index].y+15)>10)&&((ML[index].y+15)<191) ) vsetpix(ML[index].x+i, ML[index].y+15, 254);
  for ( i=14; i<18; i++ ) if ( ((ML[index].x+i)<314)&&((ML[index].x+i)>73)&&((ML[index].y+15)>10)&&((ML[index].y+15)<191) ) vsetpix(ML[index].x+i, ML[index].y+15, 254);
  //---------------------------- X-Werte ------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+ 2)<314)&&((ML[index].x+ 2)>73)&&((ML[index].y+i)>10)&&((ML[index].y+i)<191) ) vsetpix(ML[index].x+2,  ML[index].y+i,  254);
  for ( i=12; i<16; i++ ) if ( ((ML[index].x+ 2)<314)&&((ML[index].x+ 2)>73)&&((ML[index].y+i)>10)&&((ML[index].y+i)<191) ) vsetpix(ML[index].x+2,  ML[index].y+i,  254);
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+17)<314)&&((ML[index].x+17)>73)&&((ML[index].y+i)>10)&&((ML[index].y+i)<191) ) vsetpix(ML[index].x+17, ML[index].y+i,  254);
  for ( i=12; i<16; i++ ) if ( ((ML[index].x+17)<314)&&((ML[index].x+17)>73)&&((ML[index].y+i)>10)&&((ML[index].y+i)<191) ) vsetpix(ML[index].x+17, ML[index].y+i,  254);
}

void Mann_compute ( BYTE index )
{
  int i;
  BYTE links=0, rechts=0;

  if ( MannListe[index].del >= mann_del-MannListe[index].energie )    // Ist der Mann berhaupt an der Reihe
  {
    MannListe[index].del = 0;
//------------------------------ Nach RECHTS --------------------------------
    if ( MannListe[index].ax < MannListe[index].dx )
    {
      MannListe[index].ax+=1; MannListe[index].x+=1;
      if ( MannListe[index].shape < M1+2 ) MannListe[index].shape = M1+2;
      if ( MannListe[index].shape > M2   ) MannListe[index].shape = M1+2;
      MannListe[index].shape++; rechts= 1; MoveListe[index] = 1;
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( MannListe[index].ax > MannListe[index].dx )
    {
      MannListe[index].ax-=1; MannListe[index].x-=1;
      if ( MannListe[index].shape > M1 ) MannListe[index].shape = M0;
      MannListe[index].shape++; links= 1; MoveListe[index] = 1;
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( MannListe[index].ay < MannListe[index].dy )
    {
      MannListe[index].ay+=1; MannListe[index].y+=1;
      if ( MannListe[index].shape < M3+1 ) MannListe[index].shape = M3+1;
      if ( MannListe[index].shape > M4 ) MannListe[index].shape = M3+1;
      MannListe[index].shape++; MoveListe[index] = 1;
      if ( links ==  1 ) ML[index].shape=M4+3;
      if ( rechts == 1 ) ML[index].shape=M4+5;
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( MannListe[index].ay > MannListe[index].dy )
    {
      MannListe[index].ay-=1; MannListe[index].y-=1;
      if ( MannListe[index].shape < M2+1 ) MannListe[index].shape = M2+1;
      if ( MannListe[index].shape > M3 ) MannListe[index].shape = M2+1;
      MannListe[index].shape++; MoveListe[index] = 1;
      if ( links ==  1 ) ML[index].shape=M4+2;
      if ( rechts == 1 ) ML[index].shape=M4+4;
    }

    if ( (!MoveListe[index])&&(ML[index].shape>0) )
    {
      if ( ML[index].shape<M1+2 ) ML[index].shape=0;
      if ( ML[index].shape>M1+2 ) ML[index].shape=M1+2;
      MoveListe[index]= 1;
    }
    if ( MoveListe[index] )
    {
      BFeld[(ML[index].ay-12)/20][(ML[index].ax-75)/20] = 1;
      BFeld[((ML[index].ay-12)/20)+1][(ML[index].ax-75)/20] = 1;
      BFeld[((ML[index].ay-12)/20)-1][(ML[index].ax-75)/20] = 1;
      BFeld[((ML[index].ay-12)/20)][((ML[index].ax-75)/20)+1] = 1;
      BFeld[((ML[index].ay-12)/20)][((ML[index].ax-75)/20)-1] = 1;
      BFeld[((ML[index].ay-12)/20)+1][((ML[index].ax-75)/20)+1] = 1;
      BFeld[((ML[index].ay-12)/20)-1][((ML[index].ax-75)/20)-1] = 1;
      BFeld[((ML[index].ay-12)/20)+1][((ML[index].ax-75)/20)-1] = 1;
      BFeld[((ML[index].ay-12)/20)-1][((ML[index].ax-75)/20)+1] = 1;

      Landschaft(f_x, f_y);
    }
  }
  MannListe[index].del++;
}





