//
//  Defkon.h
//

#define MANN_SIZE       30
#define STRG            36
#define ML              MannListe
#define FL              FeindListe
#define MF              MannFeld
#define Mlinks          0   //73
#define Mrechts         320 //315
#define Moben           -1   //11
#define Munten          200 //191

typedef struct
{
          BYTE shape, feldx, feldy, energie, del, stop;      // 6byte
          int x, y, x1, y1;                                  // 8byte
          int ax, ay, ax1, ay1;                              // 8byte
          int dx, dy, dx1, dy1;                              // 8byte
} MANN;

BYTE LandData[500000], MannData[500000], MannBack[500000], FeindBack[500000];
BYTE Feld[200][200], MannFeld[200][200];
BYTE AktListe[200], MoveListe[400];
MANN MannListe[200], FeindListe[200];
int f_x=0; f_y=0, MannAnzahl= -1, FeindAnzahl= -1, scroll_del, mann_del, ss_del, sm_del;
int sdel;
int aktive = 0, aktive2 = 0;
BYTE akt[6];
int SPIEL_LANG  = 10;
int SPIEL_BREIT = 16;
int VIEW_LANG  = 4, vx=230;
int VIEW_BREIT = 3; vy=130;
int FELD_X;
int FELD_Y;
int Radar_x, Radar_y, Radar_x1, Radar_y1;
BYTE radar_akt=1;
int view_y, view_x;
BYTE view_akt;
int x_lang, y_breit, aktzaehler;
char puffer[127], punktMAP[5]=".map\0", punktLEV[5]=".lev\0";
char karte[13];
char keyb_flag, pal[768];
BYTE O_ANFANG, U_ANFANG, R_ANFANG, L_ANFANG, MANN_DIV,
     O_LANG, U_LANG, R_LANG, L_LANG;

/****************************************************************************/
/* put_sprite bring ein Sprite von 20x20 auf den Bildschirm. Zuvor mu ihr  */
/* aber die Position des Sprites im XMS bergeben werden, sowie die X- und  */
/* Y-Koordinaten.                                                           */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            x................................... X-Koordinate des Sprites */
/*            y................................... Y-Koordinate des Sprites */
/*            pos................................... Sprite-Position im XMS */
/****************************************************************************/
void put_sprite( int x, int y, unsigned int pos )
{
  int i= y, j= x, h= pos;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ ) vsetpix(x+j, y+i, LandData[h++]);
  }
}

/****************************************************************************/
/* Dies Funktion stellt das Grundgrst fr diese Spiel dar. Sie berechnet   */
/* welche Teile der Landschaft (Karte) angezeigt werden soll.               */
/* Gesteuert wird per Maus.                                                 */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            weiter_x..................... wie weit in X-Richtung scrollen */
/*            weiter_y..................... wie weit in Y_Richtung scrollen */
/****************************************************************************/
void Landschaft ( int weiter_x, int weiter_y )
{
  int i, j;

  for (i=weiter_y; i<weiter_y+SPIEL_LANG; i++)          
  {
    for (j=weiter_x; j<weiter_x+SPIEL_BREIT; j++) put_sprite((j-weiter_x)*20, (i-weiter_y)*20, Feld[i][j]*400);
  }
  button_up(10, 180, 53, "menu");
  if ( radar_akt ) draw_box(Radar_x, Radar_y, Radar_x1-1, Radar_y1+1, 247);
}


/****************************************************************************/
/* Initialisiert das Programm an sich.                                      */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void Init_Program( void )
{
  int i, Zeichen;
  char DateiName[127];

  printf("Starte Defkon17-Demo Version v1.0\n");
  if ( maus_reset() )        // berprfen ob ein Maustreiber installiert ist
  {
   printf("\n\nERROR: Es wurde kein Maustreiber gefunden!\n\n");
   exit(0);
  }
  load_ini(); ss_del = scroll_del; sm_del = mann_del;

  if ( chdir("DATA") )                       // ins DATA-Verzeichnis wechseln
  {
    printf("\n\nERROR: Kann Verzeichnis DATA nicht finden!\n\n");
    exit(0);
  }                                          
  delay(1000);
  init320x200();
  maus_off(); maus_put(160, 100);                              // Maus setzen
}

/****************************************************************************/
/* Initialisiert das ein Spiel. (vom Men aus)                              */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void Init_Spiel ( void )
{
  int i, Zeichen;
  FILE *Datei;

  MannAnzahl = FeindAnzahl = -1;
  f_x = f_y = 0;
  aktzaehler = -1;
  memset(AktListe, 0, 200);
  memset(MoveListe, 0, 400);
  memset(MannFeld, 0, 200*200);

  if ( (Datei = fopen("terrain.ref", "rb")) == NULL )     // Landschaft laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'terrain.ref' nicht laden!\n\n");
    exit(0);
  }
  i= 0; 
  while ((Zeichen = fgetc(Datei)) != EOF) LandData[i++] = (BYTE)Zeichen;
  fclose(Datei);
  if ( (Datei = fopen("mann.ref", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'mann.ref' nicht laden!\n\n");
    exit(0);
  }
  i=0;
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
  load_num();

  memset(puffer, 0, 127); strcpy(puffer, karte);
  strcat(karte, punktMAP);  load_map(karte);
  strcat(puffer, punktLEV); load_lev();

  Screen_Off();
  LoadPalette("mr-005.dbl", pal); SetPalette(pal); Set_Overscan_Color(0);
  Landschaft(0, 0);
  maus_off(); maus_put(160, 100); m_back_save(); m_place(); 
  cpy2screen(); Screen_On();

}

/****************************************************************************/
/* Maushandler fr die Funktion Spiel().                                    */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
int maus_links ( void )
{
  int i, j;


  if ( (m_x>9)&&(m_x<63)&&(m_y>179)&&(m_y<189) )
  {
     if ( spiel_menu() ) return 1; else return 0;
  }

  if ( (m_x>Mlinks)&&(m_x<Mrechts)&&(m_y>Moben)&&(m_y<Munten) )     // wenn auf Spielfeld
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( (m_x>ML[i].x-15)&&(m_x<ML[i].x+15)&&(m_y>ML[i].y-15)&&(m_y<ML[i].y+15) )
      {
        if ( AktListe[i] ) return 0;
        if ( keyb_flag != 32 )
	{
          aktzaehler = -1; aktive2 = 0; 
          for ( j=0; j<MannAnzahl+1; j++ )
	    if ( AktListe[j] )
	    {
               mann_back_restore(j); mann_set(j); AktListe[j]=0; 
	    } 
	}
        if ( aktzaehler < 5 ) { aktzaehler++; akt[aktzaehler]=i; }// 6 Leute zulassen
        AktListe[i] = 1; m_show_image=6; go=1; aktive = 1; if ( aktive == 1 ) aktive2 = 1;
	m_back_restore(); mann_back_restore(i); mann_akt_set(i); m_back_save(); m_place();
	m_taste= 0; return 0;
      }
    }
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( (AktListe[i]) )
      {
         if ( atack == 1 )
         {
           ML[i].dx = FL[MannFeld[(m_y/20)+f_y][(m_x/20)+f_x]].dx;
           ML[i].dy = FL[MannFeld[(m_y/20)+f_y][(m_x/20)+f_x]].dy;
         }
         else
         {
           ML[i].dx=((f_x+1+(m_x/20))*20); ML[i].dy=((f_y+(m_y/20))*20);
         }
         ML[i].stop=0;
      }
    }
    return 0;
  }

  return 0;
}

/****************************************************************************/
/* Maushandler fr die Funktion Spiel().                                    */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void maus_rechts ( void )
{
  int i;

  for ( i=0; i<MannAnzahl+1; i++ )
  {
    if ( AktListe[i] ) { mann_back_restore(i); mann_set(i); }
    AktListe[i] = 0;
  }
  go=0; atack=0; aktzaehler = -1; aktive = 0, aktive2 = 0;
  for (i=f_x; i<f_x+SPIEL_BREIT; i++) put_sprite((i-f_x)*20, 0, Feld[f_y][i]*400);
  screen_refresh= 1;
}

void scroll_down ( void )
{
  int i;

  sdel=0; f_y++;
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].y1=ML[i].y-=20; 
      if ( AktListe[i] ) mann_akt_set(i);
      else mann_set(i);
    }
  }
  if ( FeindAnzahl > -1 )
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].y1=FL[i].y-=20; feind_set(i);
    }
  }
  m_show_image=m_down;
}

void scroll_up ( void )
{
  int i;

  sdel=0; f_y--;
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].y1=ML[i].y+=20; 
      if ( AktListe[i] ) mann_akt_set(i);
      else mann_set(i);
    }
  }
  if ( FeindAnzahl > -1 )
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].y1=FL[i].y+=20; feind_set(i);
    }
  }
  m_show_image=m_up; 
}

void scroll_right ( void )
{
  int i;

  sdel=0; f_x++;
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].x1=ML[i].x-=20;
      if ( AktListe[i] ) mann_akt_set(i);
      else mann_set(i);
    }
  }
  if ( FeindAnzahl > -1 )
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].x1=FL[i].x-=20; feind_set(i);
    }
  }
  m_show_image=m_right; 
}

void scroll_left ( void )
{
  int i;

  sdel=0; f_x--;
  Landschaft(f_x, f_y); screen_refresh= 1;
  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      ML[i].x1=ML[i].x+=20; 
      if ( AktListe[i] ) mann_akt_set(i);
      else mann_set(i);
    }
  }
  if ( FeindAnzahl > -1 )
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].x1=FL[i].x+=20; feind_set(i);
    }
  }
  m_show_image=m_left;
}

/****************************************************************************/
/* Ld ein gespeichertes SaveGame.                                          */
/* ------------------------------------------------------------------------ */
/* Parameter: Dateiname.                                                   */
/****************************************************************************/
void load_map ( char MapName[13] )
{
  FILE *Datei;
  int i, j;

  chdir(".."); chdir("maps");

  if ( (Datei = fopen(MapName, "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann '%s' nicht laden!\n\n", MapName);
    exit(0);
  }
  FELD_X = fgetc(Datei)-4; FELD_Y = fgetc(Datei)-1; x_lang = fgetc(Datei); y_breit = fgetc(Datei);
  for (i=0; i<y_breit+1; i++ )
  {
    for (j=0; j<x_lang+1; j++ ) Feld[i][j] = fgetc(Datei);
  }
  fclose(Datei);

  chdir(".."); chdir("data");
}

/****************************************************************************/
/* Speichert das momentane Spiel ab.                                        */
/* ------------------------------------------------------------------------ */
/* Parameter: Name des SaveGames.                                           */
/****************************************************************************/
void save_game ( char Name[50] )
{
  FILE *Datei;
  char sign[2]="SM";
  int i, j;

  chdir(".."); chdir("saves");
  if ( (Datei = fopen("save-001.dat", "wb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann in Datei 'save-001.dat' nicht schreiben!\n\n");
    exit(0);
  }
  fwrite(sign, 2, 1, Datei);                                     // Signatur
  fwrite(Name, 50, 1, Datei);                                    // Savegame-Name
  fwrite(karte, 13, 1, Datei);                                   // x.map Name

  fputc(MannAnzahl, Datei);                                      // MannAnzahl
  fputc(FeindAnzahl, Datei);                                     // FeindAnzahl
  fputc(f_x, Datei); fputc(f_y, Datei);                          // Karten-Koordinaten
  for(i=0; i<=200; i++) fputc(AktListe[i], Datei);               // AktListe
  if ( (MannAnzahl > -1) )
  {
    fwrite(ML, MANN_SIZE, MannAnzahl+1, Datei);                      // Mnner
    for(i=0; i<=(MannAnzahl*400); i++) fputc(MannBack[i], Datei);  // MannBack
  }
  if ( (FeindAnzahl > -1) )
  {
    fwrite(FL, MANN_SIZE, FeindAnzahl+1, Datei);                     // Feinde
    for(i=0; i<=(FeindAnzahl*400); i++) fputc(FeindBack[i], Datei);// FeindBack
  }

  fclose(Datei);
  chdir(".."); chdir("data");
}

/****************************************************************************/
/* Ld ein zuvor gespeichertes Spiel.                                       */
/* ------------------------------------------------------------------------ */
/* Parameter: Name des SaveGames.                                           */
/****************************************************************************/
void load_game ( void )
{
  FILE *Datei;
  char sign[2], Name[50];
  int i, j;

  chdir(".."); chdir("saves");
  if ( (Datei = fopen("save-001.dat", "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann Datei 'save-001.dat' nicht laden!\n\n");
    exit(0);
  }
  fread(sign, 2, 1, Datei);                                      // Signatur
  fread(Name, 50, 1, Datei);                                     // Savegame-Name
  fread(karte, 13, 1, Datei);                                    // x.map Name

  MannAnzahl = fgetc(Datei);                                     // MannAnzahl
  FeindAnzahl = fgetc(Datei);                                    // FeindAnzahl
  f_x = fgetc(Datei); f_y = fgetc(Datei);                        // Karten-Koordinaten
  for(i=0; i<=200; i++) AktListe[i] = fgetc(Datei);              // AktListe
  if ( (MannAnzahl > -1) )
  {
    fread(ML, MANN_SIZE, MannAnzahl+1, Datei);                      // Mnner
    for(i=0; i<=(MannAnzahl*400); i++) MannBack[i] = fgetc(Datei);  // MannBack
  }
  if ( (FeindAnzahl > -1) )
  {
    fread(FL, MANN_SIZE, FeindAnzahl+1, Datei);                     // Feinde
    for(i=0; i<=(FeindAnzahl*400); i++) FeindBack[i] = fgetc(Datei);// FeindBack
  }

  fclose(Datei);
  chdir(".."); chdir("data");
}

/****************************************************************************/
/* Ld ein vorgefertigtes Spiel (*.lev).                                    */
/* ------------------------------------------------------------------------ */
/* Parameter: Name des SaveGames.                                           */
/****************************************************************************/
void load_lev ( void )
{
  FILE *Datei;
  char sign[2];
  int i, j;

  chdir(".."); chdir("maps");
  if ( (Datei = fopen(puffer, "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann Datei %s nicht laden!\n\n", puffer);
    exit(0);
  }
  MannAnzahl = FeindAnzahl = -1;

  fread(sign, 2, 1, Datei);                                      // Signatur
  MannAnzahl = fgetc(Datei)-200;                                 // MannAnzahl
  FeindAnzahl = fgetc(Datei)-200;                                // FeindAnzahl
  if ( (MannAnzahl > -1) )
  {
    fread(ML, MANN_SIZE, MannAnzahl+1, Datei);                      // Mnner
    for(i=0; i<=(MannAnzahl*400); i++) MannBack[i] = fgetc(Datei);  // MannBack
  }
  if ( (FeindAnzahl > -1) )
  {
    fread(FL, MANN_SIZE, FeindAnzahl+1, Datei);                     // Feinde
    for(i=0; i<=(FeindAnzahl*400); i++) FeindBack[i] = fgetc(Datei);// FeindBack
  }

  fclose(Datei);
  chdir(".."); chdir("data");
}

int get_ini_value ( FILE *D )
{
  char ini[5];
  int i= 0;

  memset(ini, 32, 5);
  while ( fgetc(D) != '=' );
  while ( (ini[i++] = fgetc(D)) != ':');
  return atoi(ini); 
}

/****************************************************************************/
/* Wertet die INI-Datei aus, und setzt die dazugehrigen Variablen          */
/* ------------------------------------------------------------------------ */
/* Keine Parameter.                                                         */
/****************************************************************************/
void load_ini ( void )
{
  int i;
  FILE *Datei;

  if ( (Datei = fopen("defkon.ini", "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann 'defkon.ini' nicht laden!\n\n");
    exit(0);
  }
//---------------------- scroll_del ------------------------------------------
    scroll_del = get_ini_value(Datei); 
//---------------------- mann_del --------------------------------------------
    mann_del = get_ini_value(Datei); 
//---------------------- Radar_x ---------------------------------------------
    Radar_x = get_ini_value(Datei); 
//---------------------- Radar_y ---------------------------------------------
    Radar_y = get_ini_value(Datei); 
//---------------------- Radar_x1 --------------------------------------------
    Radar_x1 = get_ini_value(Datei); 
//---------------------- Radar_y1 --------------------------------------------
    Radar_y1 = get_ini_value(Datei); 
//---------------------- radar_akt -------------------------------------------
    radar_akt = get_ini_value(Datei); i= 0;
//---------------------- karte -----------------------------------------------
  memset(karte, 0, 13); while ( fgetc(Datei) != '=' ); while ( (karte[i++] = fgetc(Datei)) != ':');
  karte[--i] = 0x00;

  fclose(Datei);
}


/****************************************************************************/
/* Wertet die NUM-Datei aus, und setzt die dazugehrigen Variablen          */
/* ------------------------------------------------------------------------ */
/* Keine Parameter.                                                         */
/****************************************************************************/
void load_num ( void )
{
  FILE *Datei;

  if ( (Datei = fopen("mann.num", "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann 'mann.num' nicht laden!\n\n");
    exit(0);
  }
//----------------------L_ANFANG ---------------------------------------------
   L_ANFANG = get_ini_value(Datei);
   L_LANG   = get_ini_value(Datei);
//----------------------R_ANFANG ---------------------------------------------
   R_ANFANG = get_ini_value(Datei);
   R_LANG   = get_ini_value(Datei);
//----------------------O_ANFANG ---------------------------------------------
   O_ANFANG = get_ini_value(Datei);
   O_LANG   = get_ini_value(Datei);
//----------------------U_ANFANG ---------------------------------------------
   U_ANFANG = get_ini_value(Datei);
   U_LANG   = get_ini_value(Datei);
//----------------------MANN_DIV ---------------------------------------------
   MANN_DIV = get_ini_value(Datei);

  fclose(Datei);
}


/****************************************************************************/
/* Beendet das Spiel.                                                       */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void quit ( void )
{
  chdir("..");
  textmodus();
  printf("Du hast diese Zeit verloren!\n");
  exit(0);
}


