//**************************************************************************//
// Das hier wird die DEFKON17 Konvertierung auf WATCOM C                    //
// -----------------------------------------------------                    //
// von Stephan Meiner                                                      //
// ab 25. Mrz 1996                                                         //
//**************************************************************************//
#include <stdio.h>
#include <conio.h>
#include <graph.h>
#include <dos.h>
#include <i86.h>
#include <gfklib.h>
#include <pcxlib.h>
#include <maus.h>


BYTE LandData[1000000], MannData[1000000];
BYTE Feld[1000][1000];
FILE *Datei;
char Dateiname[127];
int f_x=0; f_y=0, parts, p_count=0, select, x_lang, y_breit;
int SPIEL_BREIT  = 12;
int SPIEL_LANG   = 9;
int FELD_X; 
int FELD_Y; 


void main ( void )
{
  int i, j;

  init_Spiel();

  Screen_Off();
  load_PCX("rahmen.pcx"); Set_Overscan_Color(0); 
  Landschaft(0, 0); show_parts();
  cpy2screen(); Screen_On(); 

  while ( m_taste != 3 )                 
  {
    m_show_image= 1;
    maus_pos(); maus_show();
    //--------------------------------------------
    if ( (m_y>180)&&(f_y<FELD_Y) ) { scroll_down();  delay(10); }
    if ( (m_y< 10)&&(f_y>0) )      { scroll_up();    delay(10); }
    if ( (m_x>310)&&(f_x<FELD_X) ) { scroll_right(); delay(10); }
    if ( (m_x< 10)&&(f_x>0) )      { scroll_left();  delay(10); }
    //--------------------------------------------

    m_show_image= 1;
    if ( m_taste == 1 ) maus_links();
    if ( m_taste == 2 ) select = 0;

    if ( screen_refresh ) { wait_retrace(); cpy2screen(); }
  }
  quit();
}

/****************************************************************************/
/* put_sprite bring ein Sprite von 20x20 auf den Bildschirm. Zuvor mu ihr  */
/* aber die Position des Sprites im XMS bergeben werden, sowie die X- und  */
/* Y-Koordinaten.                                                           */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            x................................... X-Koordinate des Sprites */
/*            y................................... Y-Koordinate des Sprites */
/*            pos................................... Sprite-Position im XMS */
/****************************************************************************/
void put_sprite( int x, int y, unsigned int pos )
{
  int i= y, j= x, h= pos;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ ) vsetpix(x+j, y+i, LandData[h++]);
  }
}

/****************************************************************************/
/* Dies Funktion stellt das Grundgrst fr diese Spiel dar. Sie berechnet   */
/* welche Teile der Landschaft (Karte) angezeigt werden soll. 	            */
/* Gesteuert wird per Maus.						    */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            weiter_x..................... wie weit in X-Richtung scrollen */
/*            weiter_y..................... wie weit in Y_Richtung scrollen */
/****************************************************************************/
void Landschaft ( int weiter_x, int weiter_y )
{
  int i, j;

  for (i=weiter_y; i<weiter_y+SPIEL_LANG; i++)          
  {
    for (j=weiter_x; j<weiter_x+SPIEL_BREIT; j++)     
    {
      put_sprite((j-weiter_x)*20+5, (i-weiter_y)*20+11, Feld[i] [j]*400);
    }
  }
}



/****************************************************************************/
/* Initialisiert das Spiel.                                                 */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void init_Spiel( void )
{
  int i, Zeichen;
  FILE *Datei;
  char chose, DateiName[127];

  Screen_On();
  if ( maus_reset() )        // berprfen ob ein Maustreiber installiert ist
  {
   printf("\nERROR: Es wurde kein Maustreiber gefunden!\n\n");
   exit(0);
  }
  if ( chdir("DATA") )                       // ins DATA-Verzeichnis wechseln
  {
    printf("\nERROR: Kann Verzeichnis DATA nicht finden!\n\n");
    exit(0);
  }                                          
  Datei = fopen("terrain.ref", "rb");                   // Landschaft laden
  i= 0;
  while ((Zeichen = fgetc(Datei)) != EOF) LandData[i++] = (BYTE)Zeichen;
  fclose(Datei); parts = i/400;

  Datei = fopen("mann.dat", "rb");                             // Leute laden
  i= 0;
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);

  printf("\nAuswahl der Aktion: ");
  printf("\n-------------------");
  printf("\n(N)neu Karte erstellen, oder Karte (L)aden : \n"); chose = getch();

  if ( (chose == 'n')||(chose == 'N') )
  {
    printf("\nGre der Karte (max. 1000x1000): \n");
    printf("----------------------------------\n");
    printf("X-Wert: "); scanf("%d", &x_lang);  FELD_X = x_lang-12;
    printf("Y-Wert: "); scanf("%d", &y_breit); FELD_Y = y_breit-10;
  }
  if ( (chose == 'l')||(chose == 'L') )
  {
    printf("\nName der Karte die geladen werden soll: ");
    printf("\n---------------------------------------\n");
    printf("Dateiname: "); scanf("%s", DateiName);
    load_map(DateiName);
  }

  delay(100); fade_out();
  init320x200();
  delay(200);
  maus_off(); maus_put(160, 100);                              // Maus setzen
}


void scroll_down ( void )
{
  f_y++; 
  m_back_restore();
  Landschaft(f_x, f_y); screen_refresh= 1;
  m_show_image=m_down; m_back_save(); m_place();
}

void scroll_up ( void )
{
  f_y--; 
  m_back_restore();
  Landschaft(f_x, f_y); screen_refresh= 1;
  m_show_image=m_up; m_back_save(); m_place();
}

void scroll_right ( void )
{
  f_x++; 
  m_back_restore();
  Landschaft(f_x, f_y); screen_refresh= 1;
  m_show_image=m_right; m_back_save(); m_place();
}

void scroll_left ( void )
{
  f_x--; 
  m_back_restore();
  Landschaft(f_x, f_y); screen_refresh= 1;
  m_show_image=m_left; m_back_save(); m_place();
}

void load_map ( char MapName[127] )
{
  FILE *Datei;
  int i, j, x_lang, y_breit;

  chdir(".."); chdir("map");

  Datei = fopen(MapName, "rb");
  FELD_X = fgetc(Datei); FELD_Y = fgetc(Datei); x_lang = fgetc(Datei); y_breit = fgetc(Datei)+1;
  for (i=0; i<y_breit+1; i++ )
  {
    for (j=0; j<x_lang+1; j++ ) Feld[i][j] = fgetc(Datei);
  }
  fclose(Datei);

  chdir(".."); chdir("data");
}


void show_parts ( void )
{
  int i;

  for ( i=p_count; i<p_count+5; i++ ) put_sprite(275, 57+((i-p_count)*21), i*400);
}

void maus_links ( void )
{
  if ( ((m_x<285)&&(m_x>270)&&(m_y>161)&&(m_y<174))&&(p_count>0) )         { p_count--; show_parts(); delay(50); }
  if ( ((m_x<298)&&(m_x>286)&&(m_y>161)&&(m_y<174))&&(p_count<(parts-5)) ) { p_count++; show_parts(); delay(50); }

  if ( (m_x<295)&&(m_x>274)&&(m_y>15 )&&(m_y<160) ) select = ((m_y-57)/21)+p_count;
  if ( (m_y<191)&&(m_y> 11)&&(m_x> 5)&&(m_x<245) )
  {
     Feld[f_y+((m_y-5)/21)][f_x+(m_x/21)] = select;
     screen_refresh = 1;
     Landschaft(f_x, f_y); 
  }
}

/****************************************************************************/
/* Beendet das Spiel.                                                       */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void quit ( void )
{
  int i, j;
  char chose;

  fade_out();
  chdir(".."); chdir("map");
  textmodus();

  printf("\nAuswahl der Aktion: ");
  printf("\n-------------------");
  printf("\nKarte (S)ichern oder (V)erwerfen : \n"); chose = getch();

  if ( (chose == 's')||(chose == 'S') )
  {
    printf("\nDateiname fr die DEKON17-Karte: \n");
    printf("--------------------------------\n");
    printf("Datei: "); scanf("%s", Dateiname);
  
    Datei = fopen(Dateiname, "wb");
    fputc(FELD_X, Datei); fputc(FELD_Y, Datei); fputc(x_lang, Datei); fputc(y_breit, Datei);
    for (i=0; i<y_breit+1; i++ )
    {
      for (j=0; j<x_lang+1; j++ ) fputc(Feld[i][j], Datei);
    }
    fclose(Datei);
    
    chdir("..");
    printf("Gesichert!\n\n");
    exit(0);
  }
  else { chdir(".."); exit(0); }
}











