#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <i86.h>

#define TSR_START_DIGITAL	0
#define TSR_ALLOCATE_MEMORY     19
#define TSR_FREE_MEMORY		20
#define BSIZE 			0x2000L
#define GF1BSIZE 		8192L


void (far *ultramid)(void) = 0L;
typedef unsigned char byte;
typedef unsigned word;
char SoundData[100000];
typedef struct umss
{
	word		um_ofs;
	word		um_seg;
	word		um_stereo_ofs;
	word 		um_stereo_seg;
	long		um_len;
	unsigned long	um_gf1mem;
	byte		um_pan;
	word		um_volume;
	word		um_sample_rate;
	word		um_priority;
	word		um_data_type;
	word		um_callback_ofs;
	word		um_callback_seg;
} UMSS;


int um_start_digital(UMSS *umss)
{
  union REGS regs;
  struct SREGS sregs;

  regs.x.ax  = TSR_START_DIGITAL;
  sregs.es   = FP_SEG(umss);
  regs.d.edi = FP_OFF(umss);

  ultramid();
  return(regs.x.ax);
}

long um_allocate_memory(long mem)
{
  union REGS regs;

  regs.x.ax = TSR_ALLOCATE_MEMORY;
  regs.x.dx = (word)mem;
  regs.x.bx = (word)mem+2;
  ultramid();
//#define MK_LONG   (long)((void _seg *)(_DX) + (void near *)(_AX))
  mem = MK_FP(regs.x.dx, regs.x.ax);
  return(mem);
}

void um_free_memory(long mem)
{
  union REGS regs;

  regs.x.ax = TSR_FREE_MEMORY;
  regs.x.bx = (word)mem+2;
  regs.x.dx = (word)mem;
  (*ultramid)();
}


void init_Ultramid ( void )
{
  *ultramid = (void (far *)())_dos_getvect(0x78);
} 

void play_digital ( char *addr, long len, char prio )
{
  UMSS wav;

  wav.um_ofs = FP_OFF(addr);
  wav.um_seg = FP_SEG(addr);
//  wav.um_stereo_ofs = FP_OFF(stbuff);
//  wav.um_stereo_seg = FP_SEG(stbuff);
  wav.um_len = len;
  printf("\nPLAYDIGITAL: bevor Speicher allokieren!\n");
  wav.um_gf1mem = um_allocate_memory(len);
  printf("\nPLAYDIGITAL: Speicher allokieren!\n");
  wav.um_pan = 7;
  wav.um_volume = 4095;
  wav.um_sample_rate = 11*1024;
  wav.um_priority = prio;
  wav.um_data_type = 1|4;
  wav.um_callback_ofs = 0;
  wav.um_callback_seg = 0;

  um_start_digital(&wav);
  um_free_memory(wav.um_gf1mem);
}


void main ( void )
{
  FILE *Datei;
  int i, Zeichen;

  if ( (Datei = fopen("sound.ref", "rb")) == NULL )            // Leute laden
  {
    printf("\n\nERROR: Kann 'sound.ref' nicht laden!\n\n");
    exit(0);
  }
  i=0;
  while ((Zeichen = fgetc(Datei)) != EOF) SoundData[i++] = (byte)Zeichen; 
  fclose(Datei);
  printf("\nsound.ref geladen!\n");

  init_Ultramid();
  printf("\ninit_Ultramid!\n");
  play_digital(SoundData, 10882, 0);
  printf("\nfertig!\n");
}
