//
// video.h
//
#define setpix(x, y, c)         VScreen[(y)*640+(x)]=(c)
#define getpix(x, y)            VScreen[(y)*640+(x)]


byte *Screen = (byte *)0xa0000;                         // Zeiger auf den LFB
byte VScreen[640*480];
word ResX, ResY;                                  // Auflsung des Videomodus
union REGS regs;


struct VESAModeinfoblock
{
    short unsigned ModeAttributes;
    char WinAAttributes;
    char WinBAttributes;
    short unsigned WinGranularity;
    short unsigned WinSize;
    short unsigned WinASegment;
    short unsigned WinBSegment;
    short unsigned WinFuncPtroff;
    short unsigned WinFuncPtrseg;
    short unsigned BytesPerScanLine;

    short unsigned Xresolution;
    short unsigned Yresolution;
    char Xcharsize;
    char Ycharsize;
    char NumberOfPlanes;
    char BitsPerPixel;
    char NumberOfBanks;
    char MemoryModel;
    char BankSize;
    char NumberOfPages;
    char Reserved;
    char RedMasksize;
    char RedFieldposition;
    char GreenMasksize;
    char GreenFieldposition;
    char BlueMasksize;
    char BlueFieldposition;
    char ReservedMasksize;
    char ReservedFieldposition;
    char ColorModeInfo;
    int LinearPos;
    int OffscreenPos;
    short Offscreenmemory;
    char dummy[206];
}far * VesaModeInfo;


int GetVESAModeInfo ( word modus )
{
    unsigned selector,segment;
    union REGS inr,our;
    struct SREGS sr;

    memset(&sr,0,sizeof(sr));

    inr.w.ax=0x100;
    inr.w.bx=16;
    int386(0x31,&inr,&inr);

    segment=inr.w.ax;
    selector=inr.w.dx;
    VesaModeInfo=MK_FP(selector,0);

    _fmemset(VesaModeInfo,0xaa,256);           /* set VESAINFOBLOCK to 0xaa */
    memset(&RMI,0,sizeof(RMI));
    RMI.EAX=0x00004f01;
    RMI.ECX=0x00000000;
    RMI.ECX=modus;
    RMI.ES=segment;
    RMI.EDX=0;

    inr.w.ax=0x300;
    inr.h.bl=0x10;
    inr.h.bh=0;
    inr.w.cx=0;
    sr.es=FP_SEG(&RMI);
    inr.x.edi=FP_OFF(&RMI);
    int386x(0x31,&inr,&inr,&sr);

    if(RMI.EAX != 0x4f) return 0;
    if ( VesaModeInfo->ModeAttributes == 0 ) return 0; 
    if ( !(VesaModeInfo->ModeAttributes >> 7) ) return 0; 

    // Line Frame Buffer
//    Screen = VesaModeInfo->LinearPos;

    inr.w.dx=selector;
    inr.w.ax=0x4101;
    int386x(0x31,&inr,&inr,&sr);

    return 1;
}



void init640x480 ( void )
{
  union REGS reg;

  if ( !GetVESAModeInfo(0x100) )
  {
    printf("\n\nERROR: Videomodus 640x480 wird nicht untersttzt!\n");
    exit(0);
  }

  printf("\nLineFrameBuffer...... OK"); delay(100);
  printf("\nSeitenAnzahl.......... %d", VesaModeInfo->NumberOfPages); delay(100);
  printf("\nVideoMem......... %dKB\n", VesaModeInfo->Offscreenmemory); delay(1000);

  reg.x.eax = 0x4F02;
  reg.x.ebx = 0x0100;   
  int386(0x10,&reg,&reg);
  if ( reg.x.eax != 0x4F )
  {
    printf("\n\nERROR: Videomodus 640x480 wird nicht untersttzt!\n");
    exit(0);
  }

  ResX = VesaModeInfo->Xresolution;
  ResY = VesaModeInfo->Yresolution;
}


void textmodus( void )
{
   union REGS regs;

   regs.x.eax = 0x0003;               /* wieder in Textmodus zurckschalten */
   int386( 0x10, &regs, &regs );
}


void Cpy2Screen ( void )
{
     regs.w.ax = 0x4F05; regs.w.bx = 0x0000; regs.w.dx = 0x0000;
     int386( 0x10, &regs, &regs );
     memcpy(Screen, VScreen, 65536);

     regs.w.ax = 0x4F05; regs.w.bx = 0x0000; regs.w.dx = 0x0001;
     int386( 0x10, &regs, &regs );
     memcpy(Screen, &VScreen[65536], 65536);

     regs.w.ax = 0x4F05; regs.w.bx = 0x0000; regs.w.dx = 0x0002;
     int386( 0x10, &regs, &regs );
     memcpy(Screen, &VScreen[131072], 65536); 

     regs.w.ax = 0x4F05; regs.w.bx = 0x0000; regs.w.dx = 0x0003;
     int386( 0x10, &regs, &regs );
     memcpy(Screen, &VScreen[196608], 65536); 
}


